/*******************************************************************************
* File Name: AIN.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_AIN_H) /* Pins AIN_H */
#define CY_PINS_AIN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "AIN_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 AIN__PORT == 15 && ((AIN__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    AIN_Write(uint8 value) ;
void    AIN_SetDriveMode(uint8 mode) ;
uint8   AIN_ReadDataReg(void) ;
uint8   AIN_Read(void) ;
uint8   AIN_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define AIN_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define AIN_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define AIN_DM_RES_UP          PIN_DM_RES_UP
#define AIN_DM_RES_DWN         PIN_DM_RES_DWN
#define AIN_DM_OD_LO           PIN_DM_OD_LO
#define AIN_DM_OD_HI           PIN_DM_OD_HI
#define AIN_DM_STRONG          PIN_DM_STRONG
#define AIN_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define AIN_MASK               AIN__MASK
#define AIN_SHIFT              AIN__SHIFT
#define AIN_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define AIN_PS                     (* (reg8 *) AIN__PS)
/* Data Register */
#define AIN_DR                     (* (reg8 *) AIN__DR)
/* Port Number */
#define AIN_PRT_NUM                (* (reg8 *) AIN__PRT) 
/* Connect to Analog Globals */                                                  
#define AIN_AG                     (* (reg8 *) AIN__AG)                       
/* Analog MUX bux enable */
#define AIN_AMUX                   (* (reg8 *) AIN__AMUX) 
/* Bidirectional Enable */                                                        
#define AIN_BIE                    (* (reg8 *) AIN__BIE)
/* Bit-mask for Aliased Register Access */
#define AIN_BIT_MASK               (* (reg8 *) AIN__BIT_MASK)
/* Bypass Enable */
#define AIN_BYP                    (* (reg8 *) AIN__BYP)
/* Port wide control signals */                                                   
#define AIN_CTL                    (* (reg8 *) AIN__CTL)
/* Drive Modes */
#define AIN_DM0                    (* (reg8 *) AIN__DM0) 
#define AIN_DM1                    (* (reg8 *) AIN__DM1)
#define AIN_DM2                    (* (reg8 *) AIN__DM2) 
/* Input Buffer Disable Override */
#define AIN_INP_DIS                (* (reg8 *) AIN__INP_DIS)
/* LCD Common or Segment Drive */
#define AIN_LCD_COM_SEG            (* (reg8 *) AIN__LCD_COM_SEG)
/* Enable Segment LCD */
#define AIN_LCD_EN                 (* (reg8 *) AIN__LCD_EN)
/* Slew Rate Control */
#define AIN_SLW                    (* (reg8 *) AIN__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define AIN_PRTDSI__CAPS_SEL       (* (reg8 *) AIN__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define AIN_PRTDSI__DBL_SYNC_IN    (* (reg8 *) AIN__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define AIN_PRTDSI__OE_SEL0        (* (reg8 *) AIN__PRTDSI__OE_SEL0) 
#define AIN_PRTDSI__OE_SEL1        (* (reg8 *) AIN__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define AIN_PRTDSI__OUT_SEL0       (* (reg8 *) AIN__PRTDSI__OUT_SEL0) 
#define AIN_PRTDSI__OUT_SEL1       (* (reg8 *) AIN__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define AIN_PRTDSI__SYNC_OUT       (* (reg8 *) AIN__PRTDSI__SYNC_OUT) 


#if defined(AIN__INTSTAT)  /* Interrupt Registers */

    #define AIN_INTSTAT                (* (reg8 *) AIN__INTSTAT)
    #define AIN_SNAP                   (* (reg8 *) AIN__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_AIN_H */


/* [] END OF FILE */
