/*******************************************************************************
* File Name: AOUT.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_AOUT_H) /* Pins AOUT_H */
#define CY_PINS_AOUT_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "AOUT_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 AOUT__PORT == 15 && ((AOUT__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    AOUT_Write(uint8 value) ;
void    AOUT_SetDriveMode(uint8 mode) ;
uint8   AOUT_ReadDataReg(void) ;
uint8   AOUT_Read(void) ;
uint8   AOUT_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define AOUT_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define AOUT_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define AOUT_DM_RES_UP          PIN_DM_RES_UP
#define AOUT_DM_RES_DWN         PIN_DM_RES_DWN
#define AOUT_DM_OD_LO           PIN_DM_OD_LO
#define AOUT_DM_OD_HI           PIN_DM_OD_HI
#define AOUT_DM_STRONG          PIN_DM_STRONG
#define AOUT_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define AOUT_MASK               AOUT__MASK
#define AOUT_SHIFT              AOUT__SHIFT
#define AOUT_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define AOUT_PS                     (* (reg8 *) AOUT__PS)
/* Data Register */
#define AOUT_DR                     (* (reg8 *) AOUT__DR)
/* Port Number */
#define AOUT_PRT_NUM                (* (reg8 *) AOUT__PRT) 
/* Connect to Analog Globals */                                                  
#define AOUT_AG                     (* (reg8 *) AOUT__AG)                       
/* Analog MUX bux enable */
#define AOUT_AMUX                   (* (reg8 *) AOUT__AMUX) 
/* Bidirectional Enable */                                                        
#define AOUT_BIE                    (* (reg8 *) AOUT__BIE)
/* Bit-mask for Aliased Register Access */
#define AOUT_BIT_MASK               (* (reg8 *) AOUT__BIT_MASK)
/* Bypass Enable */
#define AOUT_BYP                    (* (reg8 *) AOUT__BYP)
/* Port wide control signals */                                                   
#define AOUT_CTL                    (* (reg8 *) AOUT__CTL)
/* Drive Modes */
#define AOUT_DM0                    (* (reg8 *) AOUT__DM0) 
#define AOUT_DM1                    (* (reg8 *) AOUT__DM1)
#define AOUT_DM2                    (* (reg8 *) AOUT__DM2) 
/* Input Buffer Disable Override */
#define AOUT_INP_DIS                (* (reg8 *) AOUT__INP_DIS)
/* LCD Common or Segment Drive */
#define AOUT_LCD_COM_SEG            (* (reg8 *) AOUT__LCD_COM_SEG)
/* Enable Segment LCD */
#define AOUT_LCD_EN                 (* (reg8 *) AOUT__LCD_EN)
/* Slew Rate Control */
#define AOUT_SLW                    (* (reg8 *) AOUT__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define AOUT_PRTDSI__CAPS_SEL       (* (reg8 *) AOUT__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define AOUT_PRTDSI__DBL_SYNC_IN    (* (reg8 *) AOUT__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define AOUT_PRTDSI__OE_SEL0        (* (reg8 *) AOUT__PRTDSI__OE_SEL0) 
#define AOUT_PRTDSI__OE_SEL1        (* (reg8 *) AOUT__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define AOUT_PRTDSI__OUT_SEL0       (* (reg8 *) AOUT__PRTDSI__OUT_SEL0) 
#define AOUT_PRTDSI__OUT_SEL1       (* (reg8 *) AOUT__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define AOUT_PRTDSI__SYNC_OUT       (* (reg8 *) AOUT__PRTDSI__SYNC_OUT) 


#if defined(AOUT__INTSTAT)  /* Interrupt Registers */

    #define AOUT_INTSTAT                (* (reg8 *) AOUT__INTSTAT)
    #define AOUT_SNAP                   (* (reg8 *) AOUT__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_AOUT_H */


/* [] END OF FILE */
