/*******************************************************************************
* File Name: BIT0.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_BIT0_H) /* Pins BIT0_H */
#define CY_PINS_BIT0_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "BIT0_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 BIT0__PORT == 15 && ((BIT0__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    BIT0_Write(uint8 value) ;
void    BIT0_SetDriveMode(uint8 mode) ;
uint8   BIT0_ReadDataReg(void) ;
uint8   BIT0_Read(void) ;
uint8   BIT0_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define BIT0_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define BIT0_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define BIT0_DM_RES_UP          PIN_DM_RES_UP
#define BIT0_DM_RES_DWN         PIN_DM_RES_DWN
#define BIT0_DM_OD_LO           PIN_DM_OD_LO
#define BIT0_DM_OD_HI           PIN_DM_OD_HI
#define BIT0_DM_STRONG          PIN_DM_STRONG
#define BIT0_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define BIT0_MASK               BIT0__MASK
#define BIT0_SHIFT              BIT0__SHIFT
#define BIT0_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define BIT0_PS                     (* (reg8 *) BIT0__PS)
/* Data Register */
#define BIT0_DR                     (* (reg8 *) BIT0__DR)
/* Port Number */
#define BIT0_PRT_NUM                (* (reg8 *) BIT0__PRT) 
/* Connect to Analog Globals */                                                  
#define BIT0_AG                     (* (reg8 *) BIT0__AG)                       
/* Analog MUX bux enable */
#define BIT0_AMUX                   (* (reg8 *) BIT0__AMUX) 
/* Bidirectional Enable */                                                        
#define BIT0_BIE                    (* (reg8 *) BIT0__BIE)
/* Bit-mask for Aliased Register Access */
#define BIT0_BIT_MASK               (* (reg8 *) BIT0__BIT_MASK)
/* Bypass Enable */
#define BIT0_BYP                    (* (reg8 *) BIT0__BYP)
/* Port wide control signals */                                                   
#define BIT0_CTL                    (* (reg8 *) BIT0__CTL)
/* Drive Modes */
#define BIT0_DM0                    (* (reg8 *) BIT0__DM0) 
#define BIT0_DM1                    (* (reg8 *) BIT0__DM1)
#define BIT0_DM2                    (* (reg8 *) BIT0__DM2) 
/* Input Buffer Disable Override */
#define BIT0_INP_DIS                (* (reg8 *) BIT0__INP_DIS)
/* LCD Common or Segment Drive */
#define BIT0_LCD_COM_SEG            (* (reg8 *) BIT0__LCD_COM_SEG)
/* Enable Segment LCD */
#define BIT0_LCD_EN                 (* (reg8 *) BIT0__LCD_EN)
/* Slew Rate Control */
#define BIT0_SLW                    (* (reg8 *) BIT0__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define BIT0_PRTDSI__CAPS_SEL       (* (reg8 *) BIT0__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define BIT0_PRTDSI__DBL_SYNC_IN    (* (reg8 *) BIT0__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define BIT0_PRTDSI__OE_SEL0        (* (reg8 *) BIT0__PRTDSI__OE_SEL0) 
#define BIT0_PRTDSI__OE_SEL1        (* (reg8 *) BIT0__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define BIT0_PRTDSI__OUT_SEL0       (* (reg8 *) BIT0__PRTDSI__OUT_SEL0) 
#define BIT0_PRTDSI__OUT_SEL1       (* (reg8 *) BIT0__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define BIT0_PRTDSI__SYNC_OUT       (* (reg8 *) BIT0__PRTDSI__SYNC_OUT) 


#if defined(BIT0__INTSTAT)  /* Interrupt Registers */

    #define BIT0_INTSTAT                (* (reg8 *) BIT0__INTSTAT)
    #define BIT0_SNAP                   (* (reg8 *) BIT0__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_BIT0_H */


/* [] END OF FILE */
