/*******************************************************************************
* File Name: IAC.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_IAC_H) /* Pins IAC_H */
#define CY_PINS_IAC_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "IAC_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 IAC__PORT == 15 && ((IAC__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    IAC_Write(uint8 value) ;
void    IAC_SetDriveMode(uint8 mode) ;
uint8   IAC_ReadDataReg(void) ;
uint8   IAC_Read(void) ;
uint8   IAC_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define IAC_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define IAC_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define IAC_DM_RES_UP          PIN_DM_RES_UP
#define IAC_DM_RES_DWN         PIN_DM_RES_DWN
#define IAC_DM_OD_LO           PIN_DM_OD_LO
#define IAC_DM_OD_HI           PIN_DM_OD_HI
#define IAC_DM_STRONG          PIN_DM_STRONG
#define IAC_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define IAC_MASK               IAC__MASK
#define IAC_SHIFT              IAC__SHIFT
#define IAC_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define IAC_PS                     (* (reg8 *) IAC__PS)
/* Data Register */
#define IAC_DR                     (* (reg8 *) IAC__DR)
/* Port Number */
#define IAC_PRT_NUM                (* (reg8 *) IAC__PRT) 
/* Connect to Analog Globals */                                                  
#define IAC_AG                     (* (reg8 *) IAC__AG)                       
/* Analog MUX bux enable */
#define IAC_AMUX                   (* (reg8 *) IAC__AMUX) 
/* Bidirectional Enable */                                                        
#define IAC_BIE                    (* (reg8 *) IAC__BIE)
/* Bit-mask for Aliased Register Access */
#define IAC_BIT_MASK               (* (reg8 *) IAC__BIT_MASK)
/* Bypass Enable */
#define IAC_BYP                    (* (reg8 *) IAC__BYP)
/* Port wide control signals */                                                   
#define IAC_CTL                    (* (reg8 *) IAC__CTL)
/* Drive Modes */
#define IAC_DM0                    (* (reg8 *) IAC__DM0) 
#define IAC_DM1                    (* (reg8 *) IAC__DM1)
#define IAC_DM2                    (* (reg8 *) IAC__DM2) 
/* Input Buffer Disable Override */
#define IAC_INP_DIS                (* (reg8 *) IAC__INP_DIS)
/* LCD Common or Segment Drive */
#define IAC_LCD_COM_SEG            (* (reg8 *) IAC__LCD_COM_SEG)
/* Enable Segment LCD */
#define IAC_LCD_EN                 (* (reg8 *) IAC__LCD_EN)
/* Slew Rate Control */
#define IAC_SLW                    (* (reg8 *) IAC__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define IAC_PRTDSI__CAPS_SEL       (* (reg8 *) IAC__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define IAC_PRTDSI__DBL_SYNC_IN    (* (reg8 *) IAC__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define IAC_PRTDSI__OE_SEL0        (* (reg8 *) IAC__PRTDSI__OE_SEL0) 
#define IAC_PRTDSI__OE_SEL1        (* (reg8 *) IAC__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define IAC_PRTDSI__OUT_SEL0       (* (reg8 *) IAC__PRTDSI__OUT_SEL0) 
#define IAC_PRTDSI__OUT_SEL1       (* (reg8 *) IAC__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define IAC_PRTDSI__SYNC_OUT       (* (reg8 *) IAC__PRTDSI__SYNC_OUT) 


#if defined(IAC__INTSTAT)  /* Interrupt Registers */

    #define IAC_INTSTAT                (* (reg8 *) IAC__INTSTAT)
    #define IAC_SNAP                   (* (reg8 *) IAC__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_IAC_H */


/* [] END OF FILE */
