/*******************************************************************************
* File Name: INT_K.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_INT_K_H) /* Pins INT_K_H */
#define CY_PINS_INT_K_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "INT_K_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 INT_K__PORT == 15 && ((INT_K__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    INT_K_Write(uint8 value) ;
void    INT_K_SetDriveMode(uint8 mode) ;
uint8   INT_K_ReadDataReg(void) ;
uint8   INT_K_Read(void) ;
uint8   INT_K_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define INT_K_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define INT_K_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define INT_K_DM_RES_UP          PIN_DM_RES_UP
#define INT_K_DM_RES_DWN         PIN_DM_RES_DWN
#define INT_K_DM_OD_LO           PIN_DM_OD_LO
#define INT_K_DM_OD_HI           PIN_DM_OD_HI
#define INT_K_DM_STRONG          PIN_DM_STRONG
#define INT_K_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define INT_K_MASK               INT_K__MASK
#define INT_K_SHIFT              INT_K__SHIFT
#define INT_K_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define INT_K_PS                     (* (reg8 *) INT_K__PS)
/* Data Register */
#define INT_K_DR                     (* (reg8 *) INT_K__DR)
/* Port Number */
#define INT_K_PRT_NUM                (* (reg8 *) INT_K__PRT) 
/* Connect to Analog Globals */                                                  
#define INT_K_AG                     (* (reg8 *) INT_K__AG)                       
/* Analog MUX bux enable */
#define INT_K_AMUX                   (* (reg8 *) INT_K__AMUX) 
/* Bidirectional Enable */                                                        
#define INT_K_BIE                    (* (reg8 *) INT_K__BIE)
/* Bit-mask for Aliased Register Access */
#define INT_K_BIT_MASK               (* (reg8 *) INT_K__BIT_MASK)
/* Bypass Enable */
#define INT_K_BYP                    (* (reg8 *) INT_K__BYP)
/* Port wide control signals */                                                   
#define INT_K_CTL                    (* (reg8 *) INT_K__CTL)
/* Drive Modes */
#define INT_K_DM0                    (* (reg8 *) INT_K__DM0) 
#define INT_K_DM1                    (* (reg8 *) INT_K__DM1)
#define INT_K_DM2                    (* (reg8 *) INT_K__DM2) 
/* Input Buffer Disable Override */
#define INT_K_INP_DIS                (* (reg8 *) INT_K__INP_DIS)
/* LCD Common or Segment Drive */
#define INT_K_LCD_COM_SEG            (* (reg8 *) INT_K__LCD_COM_SEG)
/* Enable Segment LCD */
#define INT_K_LCD_EN                 (* (reg8 *) INT_K__LCD_EN)
/* Slew Rate Control */
#define INT_K_SLW                    (* (reg8 *) INT_K__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define INT_K_PRTDSI__CAPS_SEL       (* (reg8 *) INT_K__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define INT_K_PRTDSI__DBL_SYNC_IN    (* (reg8 *) INT_K__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define INT_K_PRTDSI__OE_SEL0        (* (reg8 *) INT_K__PRTDSI__OE_SEL0) 
#define INT_K_PRTDSI__OE_SEL1        (* (reg8 *) INT_K__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define INT_K_PRTDSI__OUT_SEL0       (* (reg8 *) INT_K__PRTDSI__OUT_SEL0) 
#define INT_K_PRTDSI__OUT_SEL1       (* (reg8 *) INT_K__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define INT_K_PRTDSI__SYNC_OUT       (* (reg8 *) INT_K__PRTDSI__SYNC_OUT) 


#if defined(INT_K__INTSTAT)  /* Interrupt Registers */

    #define INT_K_INTSTAT                (* (reg8 *) INT_K__INTSTAT)
    #define INT_K_SNAP                   (* (reg8 *) INT_K__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_INT_K_H */


/* [] END OF FILE */
