/*******************************************************************************
* File Name: INV_E.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_INV_E_H) /* Pins INV_E_H */
#define CY_PINS_INV_E_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "INV_E_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 INV_E__PORT == 15 && ((INV_E__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    INV_E_Write(uint8 value) ;
void    INV_E_SetDriveMode(uint8 mode) ;
uint8   INV_E_ReadDataReg(void) ;
uint8   INV_E_Read(void) ;
uint8   INV_E_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define INV_E_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define INV_E_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define INV_E_DM_RES_UP          PIN_DM_RES_UP
#define INV_E_DM_RES_DWN         PIN_DM_RES_DWN
#define INV_E_DM_OD_LO           PIN_DM_OD_LO
#define INV_E_DM_OD_HI           PIN_DM_OD_HI
#define INV_E_DM_STRONG          PIN_DM_STRONG
#define INV_E_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define INV_E_MASK               INV_E__MASK
#define INV_E_SHIFT              INV_E__SHIFT
#define INV_E_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define INV_E_PS                     (* (reg8 *) INV_E__PS)
/* Data Register */
#define INV_E_DR                     (* (reg8 *) INV_E__DR)
/* Port Number */
#define INV_E_PRT_NUM                (* (reg8 *) INV_E__PRT) 
/* Connect to Analog Globals */                                                  
#define INV_E_AG                     (* (reg8 *) INV_E__AG)                       
/* Analog MUX bux enable */
#define INV_E_AMUX                   (* (reg8 *) INV_E__AMUX) 
/* Bidirectional Enable */                                                        
#define INV_E_BIE                    (* (reg8 *) INV_E__BIE)
/* Bit-mask for Aliased Register Access */
#define INV_E_BIT_MASK               (* (reg8 *) INV_E__BIT_MASK)
/* Bypass Enable */
#define INV_E_BYP                    (* (reg8 *) INV_E__BYP)
/* Port wide control signals */                                                   
#define INV_E_CTL                    (* (reg8 *) INV_E__CTL)
/* Drive Modes */
#define INV_E_DM0                    (* (reg8 *) INV_E__DM0) 
#define INV_E_DM1                    (* (reg8 *) INV_E__DM1)
#define INV_E_DM2                    (* (reg8 *) INV_E__DM2) 
/* Input Buffer Disable Override */
#define INV_E_INP_DIS                (* (reg8 *) INV_E__INP_DIS)
/* LCD Common or Segment Drive */
#define INV_E_LCD_COM_SEG            (* (reg8 *) INV_E__LCD_COM_SEG)
/* Enable Segment LCD */
#define INV_E_LCD_EN                 (* (reg8 *) INV_E__LCD_EN)
/* Slew Rate Control */
#define INV_E_SLW                    (* (reg8 *) INV_E__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define INV_E_PRTDSI__CAPS_SEL       (* (reg8 *) INV_E__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define INV_E_PRTDSI__DBL_SYNC_IN    (* (reg8 *) INV_E__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define INV_E_PRTDSI__OE_SEL0        (* (reg8 *) INV_E__PRTDSI__OE_SEL0) 
#define INV_E_PRTDSI__OE_SEL1        (* (reg8 *) INV_E__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define INV_E_PRTDSI__OUT_SEL0       (* (reg8 *) INV_E__PRTDSI__OUT_SEL0) 
#define INV_E_PRTDSI__OUT_SEL1       (* (reg8 *) INV_E__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define INV_E_PRTDSI__SYNC_OUT       (* (reg8 *) INV_E__PRTDSI__SYNC_OUT) 


#if defined(INV_E__INTSTAT)  /* Interrupt Registers */

    #define INV_E_INTSTAT                (* (reg8 *) INV_E__INTSTAT)
    #define INV_E_SNAP                   (* (reg8 *) INV_E__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_INV_E_H */


/* [] END OF FILE */
