/*******************************************************************************
* File Name: I_SDO.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_I_SDO_H) /* Pins I_SDO_H */
#define CY_PINS_I_SDO_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "I_SDO_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 I_SDO__PORT == 15 && ((I_SDO__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    I_SDO_Write(uint8 value) ;
void    I_SDO_SetDriveMode(uint8 mode) ;
uint8   I_SDO_ReadDataReg(void) ;
uint8   I_SDO_Read(void) ;
uint8   I_SDO_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define I_SDO_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define I_SDO_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define I_SDO_DM_RES_UP          PIN_DM_RES_UP
#define I_SDO_DM_RES_DWN         PIN_DM_RES_DWN
#define I_SDO_DM_OD_LO           PIN_DM_OD_LO
#define I_SDO_DM_OD_HI           PIN_DM_OD_HI
#define I_SDO_DM_STRONG          PIN_DM_STRONG
#define I_SDO_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define I_SDO_MASK               I_SDO__MASK
#define I_SDO_SHIFT              I_SDO__SHIFT
#define I_SDO_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define I_SDO_PS                     (* (reg8 *) I_SDO__PS)
/* Data Register */
#define I_SDO_DR                     (* (reg8 *) I_SDO__DR)
/* Port Number */
#define I_SDO_PRT_NUM                (* (reg8 *) I_SDO__PRT) 
/* Connect to Analog Globals */                                                  
#define I_SDO_AG                     (* (reg8 *) I_SDO__AG)                       
/* Analog MUX bux enable */
#define I_SDO_AMUX                   (* (reg8 *) I_SDO__AMUX) 
/* Bidirectional Enable */                                                        
#define I_SDO_BIE                    (* (reg8 *) I_SDO__BIE)
/* Bit-mask for Aliased Register Access */
#define I_SDO_BIT_MASK               (* (reg8 *) I_SDO__BIT_MASK)
/* Bypass Enable */
#define I_SDO_BYP                    (* (reg8 *) I_SDO__BYP)
/* Port wide control signals */                                                   
#define I_SDO_CTL                    (* (reg8 *) I_SDO__CTL)
/* Drive Modes */
#define I_SDO_DM0                    (* (reg8 *) I_SDO__DM0) 
#define I_SDO_DM1                    (* (reg8 *) I_SDO__DM1)
#define I_SDO_DM2                    (* (reg8 *) I_SDO__DM2) 
/* Input Buffer Disable Override */
#define I_SDO_INP_DIS                (* (reg8 *) I_SDO__INP_DIS)
/* LCD Common or Segment Drive */
#define I_SDO_LCD_COM_SEG            (* (reg8 *) I_SDO__LCD_COM_SEG)
/* Enable Segment LCD */
#define I_SDO_LCD_EN                 (* (reg8 *) I_SDO__LCD_EN)
/* Slew Rate Control */
#define I_SDO_SLW                    (* (reg8 *) I_SDO__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define I_SDO_PRTDSI__CAPS_SEL       (* (reg8 *) I_SDO__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define I_SDO_PRTDSI__DBL_SYNC_IN    (* (reg8 *) I_SDO__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define I_SDO_PRTDSI__OE_SEL0        (* (reg8 *) I_SDO__PRTDSI__OE_SEL0) 
#define I_SDO_PRTDSI__OE_SEL1        (* (reg8 *) I_SDO__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define I_SDO_PRTDSI__OUT_SEL0       (* (reg8 *) I_SDO__PRTDSI__OUT_SEL0) 
#define I_SDO_PRTDSI__OUT_SEL1       (* (reg8 *) I_SDO__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define I_SDO_PRTDSI__SYNC_OUT       (* (reg8 *) I_SDO__PRTDSI__SYNC_OUT) 


#if defined(I_SDO__INTSTAT)  /* Interrupt Registers */

    #define I_SDO_INTSTAT                (* (reg8 *) I_SDO__INTSTAT)
    #define I_SDO_SNAP                   (* (reg8 *) I_SDO__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_I_SDO_H */


/* [] END OF FILE */
