/*******************************************************************************
* File Name: KIN2.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_KIN2_H) /* Pins KIN2_H */
#define CY_PINS_KIN2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "KIN2_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 KIN2__PORT == 15 && ((KIN2__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    KIN2_Write(uint8 value) ;
void    KIN2_SetDriveMode(uint8 mode) ;
uint8   KIN2_ReadDataReg(void) ;
uint8   KIN2_Read(void) ;
uint8   KIN2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define KIN2_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define KIN2_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define KIN2_DM_RES_UP          PIN_DM_RES_UP
#define KIN2_DM_RES_DWN         PIN_DM_RES_DWN
#define KIN2_DM_OD_LO           PIN_DM_OD_LO
#define KIN2_DM_OD_HI           PIN_DM_OD_HI
#define KIN2_DM_STRONG          PIN_DM_STRONG
#define KIN2_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define KIN2_MASK               KIN2__MASK
#define KIN2_SHIFT              KIN2__SHIFT
#define KIN2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define KIN2_PS                     (* (reg8 *) KIN2__PS)
/* Data Register */
#define KIN2_DR                     (* (reg8 *) KIN2__DR)
/* Port Number */
#define KIN2_PRT_NUM                (* (reg8 *) KIN2__PRT) 
/* Connect to Analog Globals */                                                  
#define KIN2_AG                     (* (reg8 *) KIN2__AG)                       
/* Analog MUX bux enable */
#define KIN2_AMUX                   (* (reg8 *) KIN2__AMUX) 
/* Bidirectional Enable */                                                        
#define KIN2_BIE                    (* (reg8 *) KIN2__BIE)
/* Bit-mask for Aliased Register Access */
#define KIN2_BIT_MASK               (* (reg8 *) KIN2__BIT_MASK)
/* Bypass Enable */
#define KIN2_BYP                    (* (reg8 *) KIN2__BYP)
/* Port wide control signals */                                                   
#define KIN2_CTL                    (* (reg8 *) KIN2__CTL)
/* Drive Modes */
#define KIN2_DM0                    (* (reg8 *) KIN2__DM0) 
#define KIN2_DM1                    (* (reg8 *) KIN2__DM1)
#define KIN2_DM2                    (* (reg8 *) KIN2__DM2) 
/* Input Buffer Disable Override */
#define KIN2_INP_DIS                (* (reg8 *) KIN2__INP_DIS)
/* LCD Common or Segment Drive */
#define KIN2_LCD_COM_SEG            (* (reg8 *) KIN2__LCD_COM_SEG)
/* Enable Segment LCD */
#define KIN2_LCD_EN                 (* (reg8 *) KIN2__LCD_EN)
/* Slew Rate Control */
#define KIN2_SLW                    (* (reg8 *) KIN2__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define KIN2_PRTDSI__CAPS_SEL       (* (reg8 *) KIN2__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define KIN2_PRTDSI__DBL_SYNC_IN    (* (reg8 *) KIN2__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define KIN2_PRTDSI__OE_SEL0        (* (reg8 *) KIN2__PRTDSI__OE_SEL0) 
#define KIN2_PRTDSI__OE_SEL1        (* (reg8 *) KIN2__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define KIN2_PRTDSI__OUT_SEL0       (* (reg8 *) KIN2__PRTDSI__OUT_SEL0) 
#define KIN2_PRTDSI__OUT_SEL1       (* (reg8 *) KIN2__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define KIN2_PRTDSI__SYNC_OUT       (* (reg8 *) KIN2__PRTDSI__SYNC_OUT) 


#if defined(KIN2__INTSTAT)  /* Interrupt Registers */

    #define KIN2_INTSTAT                (* (reg8 *) KIN2__INTSTAT)
    #define KIN2_SNAP                   (* (reg8 *) KIN2__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_KIN2_H */


/* [] END OF FILE */
