/*******************************************************************************
* File Name: KeyPad_1_Columns.c  
* Version 1.90
*
* Description:
*  This file contains API to enable firmware control of a Pins component.
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#include "cytypes.h"
#include "KeyPad_1_Columns.h"

/* APIs are not generated for P15[7:6] on PSoC 5 */
#if !(CY_PSOC5A &&\
	 KeyPad_1_Columns__PORT == 15 && ((KeyPad_1_Columns__MASK & 0xC0) != 0))


/*******************************************************************************
* Function Name: KeyPad_1_Columns_Write
********************************************************************************
*
* Summary:
*  Assign a new value to the digital port's data output register.  
*
* Parameters:  
*  prtValue:  The value to be assigned to the Digital Port. 
*
* Return: 
*  None
*  
*******************************************************************************/
void KeyPad_1_Columns_Write(uint8 value) 
{
    uint8 staticBits = (KeyPad_1_Columns_DR & (uint8)(~KeyPad_1_Columns_MASK));
    KeyPad_1_Columns_DR = staticBits | ((uint8)(value << KeyPad_1_Columns_SHIFT) & KeyPad_1_Columns_MASK);
}


/*******************************************************************************
* Function Name: KeyPad_1_Columns_SetDriveMode
********************************************************************************
*
* Summary:
*  Change the drive mode on the pins of the port.
* 
* Parameters:  
*  mode:  Change the pins to this drive mode.
*
* Return: 
*  None
*
*******************************************************************************/
void KeyPad_1_Columns_SetDriveMode(uint8 mode) 
{
	CyPins_SetPinDriveMode(KeyPad_1_Columns_0, mode);
	CyPins_SetPinDriveMode(KeyPad_1_Columns_1, mode);
}


/*******************************************************************************
* Function Name: KeyPad_1_Columns_Read
********************************************************************************
*
* Summary:
*  Read the current value on the pins of the Digital Port in right justified 
*  form.
*
* Parameters:  
*  None
*
* Return: 
*  Returns the current value of the Digital Port as a right justified number
*  
* Note:
*  Macro KeyPad_1_Columns_ReadPS calls this function. 
*  
*******************************************************************************/
uint8 KeyPad_1_Columns_Read(void) 
{
    return (KeyPad_1_Columns_PS & KeyPad_1_Columns_MASK) >> KeyPad_1_Columns_SHIFT;
}


/*******************************************************************************
* Function Name: KeyPad_1_Columns_ReadDataReg
********************************************************************************
*
* Summary:
*  Read the current value assigned to a Digital Port's data output register
*
* Parameters:  
*  None 
*
* Return: 
*  Returns the current value assigned to the Digital Port's data output register
*  
*******************************************************************************/
uint8 KeyPad_1_Columns_ReadDataReg(void) 
{
    return (KeyPad_1_Columns_DR & KeyPad_1_Columns_MASK) >> KeyPad_1_Columns_SHIFT;
}


/* If Interrupts Are Enabled for this Pins component */ 
#if defined(KeyPad_1_Columns_INTSTAT) 

    /*******************************************************************************
    * Function Name: KeyPad_1_Columns_ClearInterrupt
    ********************************************************************************
    * Summary:
    *  Clears any active interrupts attached to port and returns the value of the 
    *  interrupt status register.
    *
    * Parameters:  
    *  None 
    *
    * Return: 
    *  Returns the value of the interrupt status register
    *  
    *******************************************************************************/
    uint8 KeyPad_1_Columns_ClearInterrupt(void) 
    {
        return (KeyPad_1_Columns_INTSTAT & KeyPad_1_Columns_MASK) >> KeyPad_1_Columns_SHIFT;
    }

#endif /* If Interrupts Are Enabled for this Pins component */ 

#endif /* CY_PSOC5A... */

    
/* [] END OF FILE */
