/*******************************************************************************
* File Name: KeyPad_1_Columns.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_KeyPad_1_Columns_H) /* Pins KeyPad_1_Columns_H */
#define CY_PINS_KeyPad_1_Columns_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "KeyPad_1_Columns_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 KeyPad_1_Columns__PORT == 15 && ((KeyPad_1_Columns__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    KeyPad_1_Columns_Write(uint8 value) ;
void    KeyPad_1_Columns_SetDriveMode(uint8 mode) ;
uint8   KeyPad_1_Columns_ReadDataReg(void) ;
uint8   KeyPad_1_Columns_Read(void) ;
uint8   KeyPad_1_Columns_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define KeyPad_1_Columns_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define KeyPad_1_Columns_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define KeyPad_1_Columns_DM_RES_UP          PIN_DM_RES_UP
#define KeyPad_1_Columns_DM_RES_DWN         PIN_DM_RES_DWN
#define KeyPad_1_Columns_DM_OD_LO           PIN_DM_OD_LO
#define KeyPad_1_Columns_DM_OD_HI           PIN_DM_OD_HI
#define KeyPad_1_Columns_DM_STRONG          PIN_DM_STRONG
#define KeyPad_1_Columns_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define KeyPad_1_Columns_MASK               KeyPad_1_Columns__MASK
#define KeyPad_1_Columns_SHIFT              KeyPad_1_Columns__SHIFT
#define KeyPad_1_Columns_WIDTH              2u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define KeyPad_1_Columns_PS                     (* (reg8 *) KeyPad_1_Columns__PS)
/* Data Register */
#define KeyPad_1_Columns_DR                     (* (reg8 *) KeyPad_1_Columns__DR)
/* Port Number */
#define KeyPad_1_Columns_PRT_NUM                (* (reg8 *) KeyPad_1_Columns__PRT) 
/* Connect to Analog Globals */                                                  
#define KeyPad_1_Columns_AG                     (* (reg8 *) KeyPad_1_Columns__AG)                       
/* Analog MUX bux enable */
#define KeyPad_1_Columns_AMUX                   (* (reg8 *) KeyPad_1_Columns__AMUX) 
/* Bidirectional Enable */                                                        
#define KeyPad_1_Columns_BIE                    (* (reg8 *) KeyPad_1_Columns__BIE)
/* Bit-mask for Aliased Register Access */
#define KeyPad_1_Columns_BIT_MASK               (* (reg8 *) KeyPad_1_Columns__BIT_MASK)
/* Bypass Enable */
#define KeyPad_1_Columns_BYP                    (* (reg8 *) KeyPad_1_Columns__BYP)
/* Port wide control signals */                                                   
#define KeyPad_1_Columns_CTL                    (* (reg8 *) KeyPad_1_Columns__CTL)
/* Drive Modes */
#define KeyPad_1_Columns_DM0                    (* (reg8 *) KeyPad_1_Columns__DM0) 
#define KeyPad_1_Columns_DM1                    (* (reg8 *) KeyPad_1_Columns__DM1)
#define KeyPad_1_Columns_DM2                    (* (reg8 *) KeyPad_1_Columns__DM2) 
/* Input Buffer Disable Override */
#define KeyPad_1_Columns_INP_DIS                (* (reg8 *) KeyPad_1_Columns__INP_DIS)
/* LCD Common or Segment Drive */
#define KeyPad_1_Columns_LCD_COM_SEG            (* (reg8 *) KeyPad_1_Columns__LCD_COM_SEG)
/* Enable Segment LCD */
#define KeyPad_1_Columns_LCD_EN                 (* (reg8 *) KeyPad_1_Columns__LCD_EN)
/* Slew Rate Control */
#define KeyPad_1_Columns_SLW                    (* (reg8 *) KeyPad_1_Columns__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define KeyPad_1_Columns_PRTDSI__CAPS_SEL       (* (reg8 *) KeyPad_1_Columns__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define KeyPad_1_Columns_PRTDSI__DBL_SYNC_IN    (* (reg8 *) KeyPad_1_Columns__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define KeyPad_1_Columns_PRTDSI__OE_SEL0        (* (reg8 *) KeyPad_1_Columns__PRTDSI__OE_SEL0) 
#define KeyPad_1_Columns_PRTDSI__OE_SEL1        (* (reg8 *) KeyPad_1_Columns__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define KeyPad_1_Columns_PRTDSI__OUT_SEL0       (* (reg8 *) KeyPad_1_Columns__PRTDSI__OUT_SEL0) 
#define KeyPad_1_Columns_PRTDSI__OUT_SEL1       (* (reg8 *) KeyPad_1_Columns__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define KeyPad_1_Columns_PRTDSI__SYNC_OUT       (* (reg8 *) KeyPad_1_Columns__PRTDSI__SYNC_OUT) 


#if defined(KeyPad_1_Columns__INTSTAT)  /* Interrupt Registers */

    #define KeyPad_1_Columns_INTSTAT                (* (reg8 *) KeyPad_1_Columns__INTSTAT)
    #define KeyPad_1_Columns_SNAP                   (* (reg8 *) KeyPad_1_Columns__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_KeyPad_1_Columns_H */


/* [] END OF FILE */
