/*******************************************************************************
* File Name: KeyPad_1_KbdScan_Int.c  
* Version 1.70
*
*  Description:
*   API for controlling the state of an interrupt.
*
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/


#include <cydevice_trm.h>
#include <CyLib.h>
#include <KeyPad_1_KbdScan_Int.h>

#if !defined(KeyPad_1_KbdScan_Int__REMOVED) /* Check for removal by optimization */

/*******************************************************************************
*  Place your includes, defines and code here 
********************************************************************************/
/* `#START KeyPad_1_KbdScan_Int_intc` */

/* `#END` */

#ifndef CYINT_IRQ_BASE
#define CYINT_IRQ_BASE      16
#endif /* CYINT_IRQ_BASE */
#ifndef CYINT_VECT_TABLE
#define CYINT_VECT_TABLE    ((cyisraddress **) CYREG_NVIC_VECT_OFFSET)
#endif /* CYINT_VECT_TABLE */

/* Declared in startup, used to set unused interrupts to. */
CY_ISR_PROTO(IntDefaultHandler);


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_Start
********************************************************************************
*
* Summary:
*  Set up the interrupt and enable it.
*
* Parameters:  
*   None
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_Start(void)
{
    /* For all we know the interrupt is active. */
    KeyPad_1_KbdScan_Int_Disable();

    /* Set the ISR to point to the KeyPad_1_KbdScan_Int Interrupt. */
    KeyPad_1_KbdScan_Int_SetVector(&KeyPad_1_KbdScan_Int_Interrupt);

    /* Set the priority. */
    KeyPad_1_KbdScan_Int_SetPriority((uint8)KeyPad_1_KbdScan_Int_INTC_PRIOR_NUMBER);

    /* Enable it. */
    KeyPad_1_KbdScan_Int_Enable();
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_StartEx
********************************************************************************
*
* Summary:
*  Set up the interrupt and enable it.
*
* Parameters:  
*   address: Address of the ISR to set in the interrupt vector table.
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_StartEx(cyisraddress address)
{
    /* For all we know the interrupt is active. */
    KeyPad_1_KbdScan_Int_Disable();

    /* Set the ISR to point to the KeyPad_1_KbdScan_Int Interrupt. */
    KeyPad_1_KbdScan_Int_SetVector(address);

    /* Set the priority. */
    KeyPad_1_KbdScan_Int_SetPriority((uint8)KeyPad_1_KbdScan_Int_INTC_PRIOR_NUMBER);

    /* Enable it. */
    KeyPad_1_KbdScan_Int_Enable();
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_Stop
********************************************************************************
*
* Summary:
*   Disables and removes the interrupt.
*
* Parameters:  
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_Stop(void)
{
    /* Disable this interrupt. */
    KeyPad_1_KbdScan_Int_Disable();

    /* Set the ISR to point to the passive one. */
    KeyPad_1_KbdScan_Int_SetVector(&IntDefaultHandler);
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_Interrupt
********************************************************************************
*
* Summary:
*   The default Interrupt Service Routine for KeyPad_1_KbdScan_Int.
*
*   Add custom code between the coments to keep the next version of this file
*   from over writting your code.
*
* Parameters:  
*
* Return:
*   None
*
*******************************************************************************/
CY_ISR(KeyPad_1_KbdScan_Int_Interrupt)
{
    /*  Place your Interrupt code here. */
    /* `#START KeyPad_1_KbdScan_Int_Interrupt` */

    /* `#END` */
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_SetVector
********************************************************************************
*
* Summary:
*   Change the ISR vector for the Interrupt. Note calling KeyPad_1_KbdScan_Int_Start
*   will override any effect this method would have had. To set the vector 
*   before the component has been started use KeyPad_1_KbdScan_Int_StartEx instead.
*
* Parameters:
*   address: Address of the ISR to set in the interrupt vector table.
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_SetVector(cyisraddress address)
{
    cyisraddress * ramVectorTable;

    ramVectorTable = (cyisraddress *) *CYINT_VECT_TABLE;

    ramVectorTable[CYINT_IRQ_BASE + (uint32)KeyPad_1_KbdScan_Int__INTC_NUMBER] = address;
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_GetVector
********************************************************************************
*
* Summary:
*   Gets the "address" of the current ISR vector for the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   Address of the ISR in the interrupt vector table.
*
*******************************************************************************/
cyisraddress KeyPad_1_KbdScan_Int_GetVector(void)
{
    cyisraddress * ramVectorTable;

    ramVectorTable = (cyisraddress *) *CYINT_VECT_TABLE;

    return ramVectorTable[CYINT_IRQ_BASE + (uint32)KeyPad_1_KbdScan_Int__INTC_NUMBER];
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_SetPriority
********************************************************************************
*
* Summary:
*   Sets the Priority of the Interrupt. Note calling KeyPad_1_KbdScan_Int_Start
*   or KeyPad_1_KbdScan_Int_StartEx will override any effect this method 
*   would have had. This method should only be called after 
*   KeyPad_1_KbdScan_Int_Start or KeyPad_1_KbdScan_Int_StartEx has been called. To set 
*   the initial priority for the component use the cydwr file in the tool.
*
* Parameters:
*   priority: Priority of the interrupt. 0 - 7, 0 being the highest.
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_SetPriority(uint8 priority)
{
    *KeyPad_1_KbdScan_Int_INTC_PRIOR = priority << 5;
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_GetPriority
********************************************************************************
*
* Summary:
*   Gets the Priority of the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   Priority of the interrupt. 0 - 7, 0 being the highest.
*
*******************************************************************************/
uint8 KeyPad_1_KbdScan_Int_GetPriority(void)
{
    uint8 priority;


    priority = *KeyPad_1_KbdScan_Int_INTC_PRIOR >> 5;

    return priority;
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_Enable
********************************************************************************
*
* Summary:
*   Enables the interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_Enable(void)
{
    /* Enable the general interrupt. */
    *KeyPad_1_KbdScan_Int_INTC_SET_EN = KeyPad_1_KbdScan_Int__INTC_MASK;
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_GetState
********************************************************************************
*
* Summary:
*   Gets the state (enabled, disabled) of the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   1 if enabled, 0 if disabled.
*
*******************************************************************************/
uint8 KeyPad_1_KbdScan_Int_GetState(void)
{
    /* Get the state of the general interrupt. */
    return ((*KeyPad_1_KbdScan_Int_INTC_SET_EN & (uint32)KeyPad_1_KbdScan_Int__INTC_MASK) != 0u) ? 1u:0u;
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_Disable
********************************************************************************
*
* Summary:
*   Disables the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_Disable(void)
{
    /* Disable the general interrupt. */
    *KeyPad_1_KbdScan_Int_INTC_CLR_EN = KeyPad_1_KbdScan_Int__INTC_MASK;
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_SetPending
********************************************************************************
*
* Summary:
*   Causes the Interrupt to enter the pending state, a software method of
*   generating the interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_SetPending(void)
{
    *KeyPad_1_KbdScan_Int_INTC_SET_PD = KeyPad_1_KbdScan_Int__INTC_MASK;
}


/*******************************************************************************
* Function Name: KeyPad_1_KbdScan_Int_ClearPending
********************************************************************************
*
* Summary:
*   Clears a pending interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void KeyPad_1_KbdScan_Int_ClearPending(void)
{
    *KeyPad_1_KbdScan_Int_INTC_CLR_PD = KeyPad_1_KbdScan_Int__INTC_MASK;
}

#endif /* End check for removal by optimization */


/* [] END OF FILE */
