/*******************************************************************************
* File Name: MDV_H_L.c  
* Version 1.90
*
* Description:
*  This file contains API to enable firmware control of a Pins component.
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#include "cytypes.h"
#include "MDV_H_L.h"

/* APIs are not generated for P15[7:6] on PSoC 5 */
#if !(CY_PSOC5A &&\
	 MDV_H_L__PORT == 15 && ((MDV_H_L__MASK & 0xC0) != 0))


/*******************************************************************************
* Function Name: MDV_H_L_Write
********************************************************************************
*
* Summary:
*  Assign a new value to the digital port's data output register.  
*
* Parameters:  
*  prtValue:  The value to be assigned to the Digital Port. 
*
* Return: 
*  None
*  
*******************************************************************************/
void MDV_H_L_Write(uint8 value) 
{
    uint8 staticBits = (MDV_H_L_DR & (uint8)(~MDV_H_L_MASK));
    MDV_H_L_DR = staticBits | ((uint8)(value << MDV_H_L_SHIFT) & MDV_H_L_MASK);
}


/*******************************************************************************
* Function Name: MDV_H_L_SetDriveMode
********************************************************************************
*
* Summary:
*  Change the drive mode on the pins of the port.
* 
* Parameters:  
*  mode:  Change the pins to this drive mode.
*
* Return: 
*  None
*
*******************************************************************************/
void MDV_H_L_SetDriveMode(uint8 mode) 
{
	CyPins_SetPinDriveMode(MDV_H_L_0, mode);
}


/*******************************************************************************
* Function Name: MDV_H_L_Read
********************************************************************************
*
* Summary:
*  Read the current value on the pins of the Digital Port in right justified 
*  form.
*
* Parameters:  
*  None
*
* Return: 
*  Returns the current value of the Digital Port as a right justified number
*  
* Note:
*  Macro MDV_H_L_ReadPS calls this function. 
*  
*******************************************************************************/
uint8 MDV_H_L_Read(void) 
{
    return (MDV_H_L_PS & MDV_H_L_MASK) >> MDV_H_L_SHIFT;
}


/*******************************************************************************
* Function Name: MDV_H_L_ReadDataReg
********************************************************************************
*
* Summary:
*  Read the current value assigned to a Digital Port's data output register
*
* Parameters:  
*  None 
*
* Return: 
*  Returns the current value assigned to the Digital Port's data output register
*  
*******************************************************************************/
uint8 MDV_H_L_ReadDataReg(void) 
{
    return (MDV_H_L_DR & MDV_H_L_MASK) >> MDV_H_L_SHIFT;
}


/* If Interrupts Are Enabled for this Pins component */ 
#if defined(MDV_H_L_INTSTAT) 

    /*******************************************************************************
    * Function Name: MDV_H_L_ClearInterrupt
    ********************************************************************************
    * Summary:
    *  Clears any active interrupts attached to port and returns the value of the 
    *  interrupt status register.
    *
    * Parameters:  
    *  None 
    *
    * Return: 
    *  Returns the value of the interrupt status register
    *  
    *******************************************************************************/
    uint8 MDV_H_L_ClearInterrupt(void) 
    {
        return (MDV_H_L_INTSTAT & MDV_H_L_MASK) >> MDV_H_L_SHIFT;
    }

#endif /* If Interrupts Are Enabled for this Pins component */ 

#endif /* CY_PSOC5A... */

    
/* [] END OF FILE */
