/*******************************************************************************
* File Name: MOK_US.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_MOK_US_H) /* Pins MOK_US_H */
#define CY_PINS_MOK_US_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "MOK_US_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 MOK_US__PORT == 15 && ((MOK_US__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    MOK_US_Write(uint8 value) ;
void    MOK_US_SetDriveMode(uint8 mode) ;
uint8   MOK_US_ReadDataReg(void) ;
uint8   MOK_US_Read(void) ;
uint8   MOK_US_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define MOK_US_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define MOK_US_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define MOK_US_DM_RES_UP          PIN_DM_RES_UP
#define MOK_US_DM_RES_DWN         PIN_DM_RES_DWN
#define MOK_US_DM_OD_LO           PIN_DM_OD_LO
#define MOK_US_DM_OD_HI           PIN_DM_OD_HI
#define MOK_US_DM_STRONG          PIN_DM_STRONG
#define MOK_US_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define MOK_US_MASK               MOK_US__MASK
#define MOK_US_SHIFT              MOK_US__SHIFT
#define MOK_US_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define MOK_US_PS                     (* (reg8 *) MOK_US__PS)
/* Data Register */
#define MOK_US_DR                     (* (reg8 *) MOK_US__DR)
/* Port Number */
#define MOK_US_PRT_NUM                (* (reg8 *) MOK_US__PRT) 
/* Connect to Analog Globals */                                                  
#define MOK_US_AG                     (* (reg8 *) MOK_US__AG)                       
/* Analog MUX bux enable */
#define MOK_US_AMUX                   (* (reg8 *) MOK_US__AMUX) 
/* Bidirectional Enable */                                                        
#define MOK_US_BIE                    (* (reg8 *) MOK_US__BIE)
/* Bit-mask for Aliased Register Access */
#define MOK_US_BIT_MASK               (* (reg8 *) MOK_US__BIT_MASK)
/* Bypass Enable */
#define MOK_US_BYP                    (* (reg8 *) MOK_US__BYP)
/* Port wide control signals */                                                   
#define MOK_US_CTL                    (* (reg8 *) MOK_US__CTL)
/* Drive Modes */
#define MOK_US_DM0                    (* (reg8 *) MOK_US__DM0) 
#define MOK_US_DM1                    (* (reg8 *) MOK_US__DM1)
#define MOK_US_DM2                    (* (reg8 *) MOK_US__DM2) 
/* Input Buffer Disable Override */
#define MOK_US_INP_DIS                (* (reg8 *) MOK_US__INP_DIS)
/* LCD Common or Segment Drive */
#define MOK_US_LCD_COM_SEG            (* (reg8 *) MOK_US__LCD_COM_SEG)
/* Enable Segment LCD */
#define MOK_US_LCD_EN                 (* (reg8 *) MOK_US__LCD_EN)
/* Slew Rate Control */
#define MOK_US_SLW                    (* (reg8 *) MOK_US__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define MOK_US_PRTDSI__CAPS_SEL       (* (reg8 *) MOK_US__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define MOK_US_PRTDSI__DBL_SYNC_IN    (* (reg8 *) MOK_US__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define MOK_US_PRTDSI__OE_SEL0        (* (reg8 *) MOK_US__PRTDSI__OE_SEL0) 
#define MOK_US_PRTDSI__OE_SEL1        (* (reg8 *) MOK_US__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define MOK_US_PRTDSI__OUT_SEL0       (* (reg8 *) MOK_US__PRTDSI__OUT_SEL0) 
#define MOK_US_PRTDSI__OUT_SEL1       (* (reg8 *) MOK_US__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define MOK_US_PRTDSI__SYNC_OUT       (* (reg8 *) MOK_US__PRTDSI__SYNC_OUT) 


#if defined(MOK_US__INTSTAT)  /* Interrupt Registers */

    #define MOK_US_INTSTAT                (* (reg8 *) MOK_US__INTSTAT)
    #define MOK_US_SNAP                   (* (reg8 *) MOK_US__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_MOK_US_H */


/* [] END OF FILE */
