/*******************************************************************************
* File Name: M_IN2.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_M_IN2_H) /* Pins M_IN2_H */
#define CY_PINS_M_IN2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "M_IN2_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 M_IN2__PORT == 15 && ((M_IN2__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    M_IN2_Write(uint8 value) ;
void    M_IN2_SetDriveMode(uint8 mode) ;
uint8   M_IN2_ReadDataReg(void) ;
uint8   M_IN2_Read(void) ;
uint8   M_IN2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define M_IN2_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define M_IN2_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define M_IN2_DM_RES_UP          PIN_DM_RES_UP
#define M_IN2_DM_RES_DWN         PIN_DM_RES_DWN
#define M_IN2_DM_OD_LO           PIN_DM_OD_LO
#define M_IN2_DM_OD_HI           PIN_DM_OD_HI
#define M_IN2_DM_STRONG          PIN_DM_STRONG
#define M_IN2_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define M_IN2_MASK               M_IN2__MASK
#define M_IN2_SHIFT              M_IN2__SHIFT
#define M_IN2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define M_IN2_PS                     (* (reg8 *) M_IN2__PS)
/* Data Register */
#define M_IN2_DR                     (* (reg8 *) M_IN2__DR)
/* Port Number */
#define M_IN2_PRT_NUM                (* (reg8 *) M_IN2__PRT) 
/* Connect to Analog Globals */                                                  
#define M_IN2_AG                     (* (reg8 *) M_IN2__AG)                       
/* Analog MUX bux enable */
#define M_IN2_AMUX                   (* (reg8 *) M_IN2__AMUX) 
/* Bidirectional Enable */                                                        
#define M_IN2_BIE                    (* (reg8 *) M_IN2__BIE)
/* Bit-mask for Aliased Register Access */
#define M_IN2_BIT_MASK               (* (reg8 *) M_IN2__BIT_MASK)
/* Bypass Enable */
#define M_IN2_BYP                    (* (reg8 *) M_IN2__BYP)
/* Port wide control signals */                                                   
#define M_IN2_CTL                    (* (reg8 *) M_IN2__CTL)
/* Drive Modes */
#define M_IN2_DM0                    (* (reg8 *) M_IN2__DM0) 
#define M_IN2_DM1                    (* (reg8 *) M_IN2__DM1)
#define M_IN2_DM2                    (* (reg8 *) M_IN2__DM2) 
/* Input Buffer Disable Override */
#define M_IN2_INP_DIS                (* (reg8 *) M_IN2__INP_DIS)
/* LCD Common or Segment Drive */
#define M_IN2_LCD_COM_SEG            (* (reg8 *) M_IN2__LCD_COM_SEG)
/* Enable Segment LCD */
#define M_IN2_LCD_EN                 (* (reg8 *) M_IN2__LCD_EN)
/* Slew Rate Control */
#define M_IN2_SLW                    (* (reg8 *) M_IN2__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define M_IN2_PRTDSI__CAPS_SEL       (* (reg8 *) M_IN2__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define M_IN2_PRTDSI__DBL_SYNC_IN    (* (reg8 *) M_IN2__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define M_IN2_PRTDSI__OE_SEL0        (* (reg8 *) M_IN2__PRTDSI__OE_SEL0) 
#define M_IN2_PRTDSI__OE_SEL1        (* (reg8 *) M_IN2__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define M_IN2_PRTDSI__OUT_SEL0       (* (reg8 *) M_IN2__PRTDSI__OUT_SEL0) 
#define M_IN2_PRTDSI__OUT_SEL1       (* (reg8 *) M_IN2__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define M_IN2_PRTDSI__SYNC_OUT       (* (reg8 *) M_IN2__PRTDSI__SYNC_OUT) 


#if defined(M_IN2__INTSTAT)  /* Interrupt Registers */

    #define M_IN2_INTSTAT                (* (reg8 *) M_IN2__INTSTAT)
    #define M_IN2_SNAP                   (* (reg8 *) M_IN2__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_M_IN2_H */


/* [] END OF FILE */
