/*******************************************************************************
* File Name: PWR1.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PWR1_H) /* Pins PWR1_H */
#define CY_PINS_PWR1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PWR1_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 PWR1__PORT == 15 && ((PWR1__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    PWR1_Write(uint8 value) ;
void    PWR1_SetDriveMode(uint8 mode) ;
uint8   PWR1_ReadDataReg(void) ;
uint8   PWR1_Read(void) ;
uint8   PWR1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PWR1_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PWR1_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PWR1_DM_RES_UP          PIN_DM_RES_UP
#define PWR1_DM_RES_DWN         PIN_DM_RES_DWN
#define PWR1_DM_OD_LO           PIN_DM_OD_LO
#define PWR1_DM_OD_HI           PIN_DM_OD_HI
#define PWR1_DM_STRONG          PIN_DM_STRONG
#define PWR1_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PWR1_MASK               PWR1__MASK
#define PWR1_SHIFT              PWR1__SHIFT
#define PWR1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PWR1_PS                     (* (reg8 *) PWR1__PS)
/* Data Register */
#define PWR1_DR                     (* (reg8 *) PWR1__DR)
/* Port Number */
#define PWR1_PRT_NUM                (* (reg8 *) PWR1__PRT) 
/* Connect to Analog Globals */                                                  
#define PWR1_AG                     (* (reg8 *) PWR1__AG)                       
/* Analog MUX bux enable */
#define PWR1_AMUX                   (* (reg8 *) PWR1__AMUX) 
/* Bidirectional Enable */                                                        
#define PWR1_BIE                    (* (reg8 *) PWR1__BIE)
/* Bit-mask for Aliased Register Access */
#define PWR1_BIT_MASK               (* (reg8 *) PWR1__BIT_MASK)
/* Bypass Enable */
#define PWR1_BYP                    (* (reg8 *) PWR1__BYP)
/* Port wide control signals */                                                   
#define PWR1_CTL                    (* (reg8 *) PWR1__CTL)
/* Drive Modes */
#define PWR1_DM0                    (* (reg8 *) PWR1__DM0) 
#define PWR1_DM1                    (* (reg8 *) PWR1__DM1)
#define PWR1_DM2                    (* (reg8 *) PWR1__DM2) 
/* Input Buffer Disable Override */
#define PWR1_INP_DIS                (* (reg8 *) PWR1__INP_DIS)
/* LCD Common or Segment Drive */
#define PWR1_LCD_COM_SEG            (* (reg8 *) PWR1__LCD_COM_SEG)
/* Enable Segment LCD */
#define PWR1_LCD_EN                 (* (reg8 *) PWR1__LCD_EN)
/* Slew Rate Control */
#define PWR1_SLW                    (* (reg8 *) PWR1__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PWR1_PRTDSI__CAPS_SEL       (* (reg8 *) PWR1__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PWR1_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PWR1__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PWR1_PRTDSI__OE_SEL0        (* (reg8 *) PWR1__PRTDSI__OE_SEL0) 
#define PWR1_PRTDSI__OE_SEL1        (* (reg8 *) PWR1__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PWR1_PRTDSI__OUT_SEL0       (* (reg8 *) PWR1__PRTDSI__OUT_SEL0) 
#define PWR1_PRTDSI__OUT_SEL1       (* (reg8 *) PWR1__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PWR1_PRTDSI__SYNC_OUT       (* (reg8 *) PWR1__PRTDSI__SYNC_OUT) 


#if defined(PWR1__INTSTAT)  /* Interrupt Registers */

    #define PWR1_INTSTAT                (* (reg8 *) PWR1__INTSTAT)
    #define PWR1_SNAP                   (* (reg8 *) PWR1__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_PWR1_H */


/* [] END OF FILE */
