/*******************************************************************************
* File Name: PWR4.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PWR4_H) /* Pins PWR4_H */
#define CY_PINS_PWR4_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PWR4_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 PWR4__PORT == 15 && ((PWR4__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    PWR4_Write(uint8 value) ;
void    PWR4_SetDriveMode(uint8 mode) ;
uint8   PWR4_ReadDataReg(void) ;
uint8   PWR4_Read(void) ;
uint8   PWR4_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PWR4_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PWR4_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PWR4_DM_RES_UP          PIN_DM_RES_UP
#define PWR4_DM_RES_DWN         PIN_DM_RES_DWN
#define PWR4_DM_OD_LO           PIN_DM_OD_LO
#define PWR4_DM_OD_HI           PIN_DM_OD_HI
#define PWR4_DM_STRONG          PIN_DM_STRONG
#define PWR4_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PWR4_MASK               PWR4__MASK
#define PWR4_SHIFT              PWR4__SHIFT
#define PWR4_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PWR4_PS                     (* (reg8 *) PWR4__PS)
/* Data Register */
#define PWR4_DR                     (* (reg8 *) PWR4__DR)
/* Port Number */
#define PWR4_PRT_NUM                (* (reg8 *) PWR4__PRT) 
/* Connect to Analog Globals */                                                  
#define PWR4_AG                     (* (reg8 *) PWR4__AG)                       
/* Analog MUX bux enable */
#define PWR4_AMUX                   (* (reg8 *) PWR4__AMUX) 
/* Bidirectional Enable */                                                        
#define PWR4_BIE                    (* (reg8 *) PWR4__BIE)
/* Bit-mask for Aliased Register Access */
#define PWR4_BIT_MASK               (* (reg8 *) PWR4__BIT_MASK)
/* Bypass Enable */
#define PWR4_BYP                    (* (reg8 *) PWR4__BYP)
/* Port wide control signals */                                                   
#define PWR4_CTL                    (* (reg8 *) PWR4__CTL)
/* Drive Modes */
#define PWR4_DM0                    (* (reg8 *) PWR4__DM0) 
#define PWR4_DM1                    (* (reg8 *) PWR4__DM1)
#define PWR4_DM2                    (* (reg8 *) PWR4__DM2) 
/* Input Buffer Disable Override */
#define PWR4_INP_DIS                (* (reg8 *) PWR4__INP_DIS)
/* LCD Common or Segment Drive */
#define PWR4_LCD_COM_SEG            (* (reg8 *) PWR4__LCD_COM_SEG)
/* Enable Segment LCD */
#define PWR4_LCD_EN                 (* (reg8 *) PWR4__LCD_EN)
/* Slew Rate Control */
#define PWR4_SLW                    (* (reg8 *) PWR4__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PWR4_PRTDSI__CAPS_SEL       (* (reg8 *) PWR4__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PWR4_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PWR4__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PWR4_PRTDSI__OE_SEL0        (* (reg8 *) PWR4__PRTDSI__OE_SEL0) 
#define PWR4_PRTDSI__OE_SEL1        (* (reg8 *) PWR4__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PWR4_PRTDSI__OUT_SEL0       (* (reg8 *) PWR4__PRTDSI__OUT_SEL0) 
#define PWR4_PRTDSI__OUT_SEL1       (* (reg8 *) PWR4__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PWR4_PRTDSI__SYNC_OUT       (* (reg8 *) PWR4__PRTDSI__SYNC_OUT) 


#if defined(PWR4__INTSTAT)  /* Interrupt Registers */

    #define PWR4_INTSTAT                (* (reg8 *) PWR4__INTSTAT)
    #define PWR4_SNAP                   (* (reg8 *) PWR4__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_PWR4_H */


/* [] END OF FILE */
