/*******************************************************************************
* File Name: PWR5.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PWR5_H) /* Pins PWR5_H */
#define CY_PINS_PWR5_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PWR5_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 PWR5__PORT == 15 && ((PWR5__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    PWR5_Write(uint8 value) ;
void    PWR5_SetDriveMode(uint8 mode) ;
uint8   PWR5_ReadDataReg(void) ;
uint8   PWR5_Read(void) ;
uint8   PWR5_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PWR5_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PWR5_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PWR5_DM_RES_UP          PIN_DM_RES_UP
#define PWR5_DM_RES_DWN         PIN_DM_RES_DWN
#define PWR5_DM_OD_LO           PIN_DM_OD_LO
#define PWR5_DM_OD_HI           PIN_DM_OD_HI
#define PWR5_DM_STRONG          PIN_DM_STRONG
#define PWR5_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PWR5_MASK               PWR5__MASK
#define PWR5_SHIFT              PWR5__SHIFT
#define PWR5_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PWR5_PS                     (* (reg8 *) PWR5__PS)
/* Data Register */
#define PWR5_DR                     (* (reg8 *) PWR5__DR)
/* Port Number */
#define PWR5_PRT_NUM                (* (reg8 *) PWR5__PRT) 
/* Connect to Analog Globals */                                                  
#define PWR5_AG                     (* (reg8 *) PWR5__AG)                       
/* Analog MUX bux enable */
#define PWR5_AMUX                   (* (reg8 *) PWR5__AMUX) 
/* Bidirectional Enable */                                                        
#define PWR5_BIE                    (* (reg8 *) PWR5__BIE)
/* Bit-mask for Aliased Register Access */
#define PWR5_BIT_MASK               (* (reg8 *) PWR5__BIT_MASK)
/* Bypass Enable */
#define PWR5_BYP                    (* (reg8 *) PWR5__BYP)
/* Port wide control signals */                                                   
#define PWR5_CTL                    (* (reg8 *) PWR5__CTL)
/* Drive Modes */
#define PWR5_DM0                    (* (reg8 *) PWR5__DM0) 
#define PWR5_DM1                    (* (reg8 *) PWR5__DM1)
#define PWR5_DM2                    (* (reg8 *) PWR5__DM2) 
/* Input Buffer Disable Override */
#define PWR5_INP_DIS                (* (reg8 *) PWR5__INP_DIS)
/* LCD Common or Segment Drive */
#define PWR5_LCD_COM_SEG            (* (reg8 *) PWR5__LCD_COM_SEG)
/* Enable Segment LCD */
#define PWR5_LCD_EN                 (* (reg8 *) PWR5__LCD_EN)
/* Slew Rate Control */
#define PWR5_SLW                    (* (reg8 *) PWR5__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PWR5_PRTDSI__CAPS_SEL       (* (reg8 *) PWR5__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PWR5_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PWR5__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PWR5_PRTDSI__OE_SEL0        (* (reg8 *) PWR5__PRTDSI__OE_SEL0) 
#define PWR5_PRTDSI__OE_SEL1        (* (reg8 *) PWR5__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PWR5_PRTDSI__OUT_SEL0       (* (reg8 *) PWR5__PRTDSI__OUT_SEL0) 
#define PWR5_PRTDSI__OUT_SEL1       (* (reg8 *) PWR5__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PWR5_PRTDSI__SYNC_OUT       (* (reg8 *) PWR5__PRTDSI__SYNC_OUT) 


#if defined(PWR5__INTSTAT)  /* Interrupt Registers */

    #define PWR5_INTSTAT                (* (reg8 *) PWR5__INTSTAT)
    #define PWR5_SNAP                   (* (reg8 *) PWR5__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_PWR5_H */


/* [] END OF FILE */
