/*******************************************************************************
* File Name: SONOX.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_SONOX_H) /* Pins SONOX_H */
#define CY_PINS_SONOX_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "SONOX_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 SONOX__PORT == 15 && ((SONOX__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    SONOX_Write(uint8 value) ;
void    SONOX_SetDriveMode(uint8 mode) ;
uint8   SONOX_ReadDataReg(void) ;
uint8   SONOX_Read(void) ;
uint8   SONOX_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define SONOX_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define SONOX_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define SONOX_DM_RES_UP          PIN_DM_RES_UP
#define SONOX_DM_RES_DWN         PIN_DM_RES_DWN
#define SONOX_DM_OD_LO           PIN_DM_OD_LO
#define SONOX_DM_OD_HI           PIN_DM_OD_HI
#define SONOX_DM_STRONG          PIN_DM_STRONG
#define SONOX_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define SONOX_MASK               SONOX__MASK
#define SONOX_SHIFT              SONOX__SHIFT
#define SONOX_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define SONOX_PS                     (* (reg8 *) SONOX__PS)
/* Data Register */
#define SONOX_DR                     (* (reg8 *) SONOX__DR)
/* Port Number */
#define SONOX_PRT_NUM                (* (reg8 *) SONOX__PRT) 
/* Connect to Analog Globals */                                                  
#define SONOX_AG                     (* (reg8 *) SONOX__AG)                       
/* Analog MUX bux enable */
#define SONOX_AMUX                   (* (reg8 *) SONOX__AMUX) 
/* Bidirectional Enable */                                                        
#define SONOX_BIE                    (* (reg8 *) SONOX__BIE)
/* Bit-mask for Aliased Register Access */
#define SONOX_BIT_MASK               (* (reg8 *) SONOX__BIT_MASK)
/* Bypass Enable */
#define SONOX_BYP                    (* (reg8 *) SONOX__BYP)
/* Port wide control signals */                                                   
#define SONOX_CTL                    (* (reg8 *) SONOX__CTL)
/* Drive Modes */
#define SONOX_DM0                    (* (reg8 *) SONOX__DM0) 
#define SONOX_DM1                    (* (reg8 *) SONOX__DM1)
#define SONOX_DM2                    (* (reg8 *) SONOX__DM2) 
/* Input Buffer Disable Override */
#define SONOX_INP_DIS                (* (reg8 *) SONOX__INP_DIS)
/* LCD Common or Segment Drive */
#define SONOX_LCD_COM_SEG            (* (reg8 *) SONOX__LCD_COM_SEG)
/* Enable Segment LCD */
#define SONOX_LCD_EN                 (* (reg8 *) SONOX__LCD_EN)
/* Slew Rate Control */
#define SONOX_SLW                    (* (reg8 *) SONOX__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define SONOX_PRTDSI__CAPS_SEL       (* (reg8 *) SONOX__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define SONOX_PRTDSI__DBL_SYNC_IN    (* (reg8 *) SONOX__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define SONOX_PRTDSI__OE_SEL0        (* (reg8 *) SONOX__PRTDSI__OE_SEL0) 
#define SONOX_PRTDSI__OE_SEL1        (* (reg8 *) SONOX__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define SONOX_PRTDSI__OUT_SEL0       (* (reg8 *) SONOX__PRTDSI__OUT_SEL0) 
#define SONOX_PRTDSI__OUT_SEL1       (* (reg8 *) SONOX__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define SONOX_PRTDSI__SYNC_OUT       (* (reg8 *) SONOX__PRTDSI__SYNC_OUT) 


#if defined(SONOX__INTSTAT)  /* Interrupt Registers */

    #define SONOX_INTSTAT                (* (reg8 *) SONOX__INTSTAT)
    #define SONOX_SNAP                   (* (reg8 *) SONOX__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_SONOX_H */


/* [] END OF FILE */
