/*******************************************************************************
* File Name: THERM_H.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_THERM_H_H) /* Pins THERM_H_H */
#define CY_PINS_THERM_H_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "THERM_H_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 THERM_H__PORT == 15 && ((THERM_H__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    THERM_H_Write(uint8 value) ;
void    THERM_H_SetDriveMode(uint8 mode) ;
uint8   THERM_H_ReadDataReg(void) ;
uint8   THERM_H_Read(void) ;
uint8   THERM_H_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define THERM_H_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define THERM_H_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define THERM_H_DM_RES_UP          PIN_DM_RES_UP
#define THERM_H_DM_RES_DWN         PIN_DM_RES_DWN
#define THERM_H_DM_OD_LO           PIN_DM_OD_LO
#define THERM_H_DM_OD_HI           PIN_DM_OD_HI
#define THERM_H_DM_STRONG          PIN_DM_STRONG
#define THERM_H_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define THERM_H_MASK               THERM_H__MASK
#define THERM_H_SHIFT              THERM_H__SHIFT
#define THERM_H_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define THERM_H_PS                     (* (reg8 *) THERM_H__PS)
/* Data Register */
#define THERM_H_DR                     (* (reg8 *) THERM_H__DR)
/* Port Number */
#define THERM_H_PRT_NUM                (* (reg8 *) THERM_H__PRT) 
/* Connect to Analog Globals */                                                  
#define THERM_H_AG                     (* (reg8 *) THERM_H__AG)                       
/* Analog MUX bux enable */
#define THERM_H_AMUX                   (* (reg8 *) THERM_H__AMUX) 
/* Bidirectional Enable */                                                        
#define THERM_H_BIE                    (* (reg8 *) THERM_H__BIE)
/* Bit-mask for Aliased Register Access */
#define THERM_H_BIT_MASK               (* (reg8 *) THERM_H__BIT_MASK)
/* Bypass Enable */
#define THERM_H_BYP                    (* (reg8 *) THERM_H__BYP)
/* Port wide control signals */                                                   
#define THERM_H_CTL                    (* (reg8 *) THERM_H__CTL)
/* Drive Modes */
#define THERM_H_DM0                    (* (reg8 *) THERM_H__DM0) 
#define THERM_H_DM1                    (* (reg8 *) THERM_H__DM1)
#define THERM_H_DM2                    (* (reg8 *) THERM_H__DM2) 
/* Input Buffer Disable Override */
#define THERM_H_INP_DIS                (* (reg8 *) THERM_H__INP_DIS)
/* LCD Common or Segment Drive */
#define THERM_H_LCD_COM_SEG            (* (reg8 *) THERM_H__LCD_COM_SEG)
/* Enable Segment LCD */
#define THERM_H_LCD_EN                 (* (reg8 *) THERM_H__LCD_EN)
/* Slew Rate Control */
#define THERM_H_SLW                    (* (reg8 *) THERM_H__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define THERM_H_PRTDSI__CAPS_SEL       (* (reg8 *) THERM_H__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define THERM_H_PRTDSI__DBL_SYNC_IN    (* (reg8 *) THERM_H__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define THERM_H_PRTDSI__OE_SEL0        (* (reg8 *) THERM_H__PRTDSI__OE_SEL0) 
#define THERM_H_PRTDSI__OE_SEL1        (* (reg8 *) THERM_H__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define THERM_H_PRTDSI__OUT_SEL0       (* (reg8 *) THERM_H__PRTDSI__OUT_SEL0) 
#define THERM_H_PRTDSI__OUT_SEL1       (* (reg8 *) THERM_H__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define THERM_H_PRTDSI__SYNC_OUT       (* (reg8 *) THERM_H__PRTDSI__SYNC_OUT) 


#if defined(THERM_H__INTSTAT)  /* Interrupt Registers */

    #define THERM_H_INTSTAT                (* (reg8 *) THERM_H__INTSTAT)
    #define THERM_H_SNAP                   (* (reg8 *) THERM_H__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_THERM_H_H */


/* [] END OF FILE */
