/*******************************************************************************
* File Name: VHALF.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_VHALF_H) /* Pins VHALF_H */
#define CY_PINS_VHALF_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "VHALF_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 VHALF__PORT == 15 && ((VHALF__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    VHALF_Write(uint8 value) ;
void    VHALF_SetDriveMode(uint8 mode) ;
uint8   VHALF_ReadDataReg(void) ;
uint8   VHALF_Read(void) ;
uint8   VHALF_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define VHALF_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define VHALF_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define VHALF_DM_RES_UP          PIN_DM_RES_UP
#define VHALF_DM_RES_DWN         PIN_DM_RES_DWN
#define VHALF_DM_OD_LO           PIN_DM_OD_LO
#define VHALF_DM_OD_HI           PIN_DM_OD_HI
#define VHALF_DM_STRONG          PIN_DM_STRONG
#define VHALF_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define VHALF_MASK               VHALF__MASK
#define VHALF_SHIFT              VHALF__SHIFT
#define VHALF_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define VHALF_PS                     (* (reg8 *) VHALF__PS)
/* Data Register */
#define VHALF_DR                     (* (reg8 *) VHALF__DR)
/* Port Number */
#define VHALF_PRT_NUM                (* (reg8 *) VHALF__PRT) 
/* Connect to Analog Globals */                                                  
#define VHALF_AG                     (* (reg8 *) VHALF__AG)                       
/* Analog MUX bux enable */
#define VHALF_AMUX                   (* (reg8 *) VHALF__AMUX) 
/* Bidirectional Enable */                                                        
#define VHALF_BIE                    (* (reg8 *) VHALF__BIE)
/* Bit-mask for Aliased Register Access */
#define VHALF_BIT_MASK               (* (reg8 *) VHALF__BIT_MASK)
/* Bypass Enable */
#define VHALF_BYP                    (* (reg8 *) VHALF__BYP)
/* Port wide control signals */                                                   
#define VHALF_CTL                    (* (reg8 *) VHALF__CTL)
/* Drive Modes */
#define VHALF_DM0                    (* (reg8 *) VHALF__DM0) 
#define VHALF_DM1                    (* (reg8 *) VHALF__DM1)
#define VHALF_DM2                    (* (reg8 *) VHALF__DM2) 
/* Input Buffer Disable Override */
#define VHALF_INP_DIS                (* (reg8 *) VHALF__INP_DIS)
/* LCD Common or Segment Drive */
#define VHALF_LCD_COM_SEG            (* (reg8 *) VHALF__LCD_COM_SEG)
/* Enable Segment LCD */
#define VHALF_LCD_EN                 (* (reg8 *) VHALF__LCD_EN)
/* Slew Rate Control */
#define VHALF_SLW                    (* (reg8 *) VHALF__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define VHALF_PRTDSI__CAPS_SEL       (* (reg8 *) VHALF__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define VHALF_PRTDSI__DBL_SYNC_IN    (* (reg8 *) VHALF__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define VHALF_PRTDSI__OE_SEL0        (* (reg8 *) VHALF__PRTDSI__OE_SEL0) 
#define VHALF_PRTDSI__OE_SEL1        (* (reg8 *) VHALF__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define VHALF_PRTDSI__OUT_SEL0       (* (reg8 *) VHALF__PRTDSI__OUT_SEL0) 
#define VHALF_PRTDSI__OUT_SEL1       (* (reg8 *) VHALF__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define VHALF_PRTDSI__SYNC_OUT       (* (reg8 *) VHALF__PRTDSI__SYNC_OUT) 


#if defined(VHALF__INTSTAT)  /* Interrupt Registers */

    #define VHALF_INTSTAT                (* (reg8 *) VHALF__INTSTAT)
    #define VHALF_SNAP                   (* (reg8 *) VHALF__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_VHALF_H */


/* [] END OF FILE */
