/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <device.h>
#include <project.h>
#include <stdlib.h>
#include <string.h>
#include "definition.h"
#include "programming.h"
#include "KeyPad_1.h"
#include <stdio.h>
//---------------------------------------------------------------------
// main()  for default ( UNIX ), is the first routine be executed
//---------------------------------------------------------------------
int main(void)
{
	Setup();				// Setup peripherals and software variable                    		// Loop forever
		{					
  			debug = 0 ; 
			if( SysTimers_1_GetTimerStatus(update_timerID_Main) &(debug == 1 ))	// 1 msec
				{
					servo_isr();
				}
			if( SysTimers_1_GetTimerStatus(update_timerID_Minutes)& (debug == 1 ))	// 1 sec
				{ 
					CalcMinutes();
					view_Temperature();								// for 10 sec
				}
			//if( SysTimers_1_GetTimerStatus(update_timerID_Keyboard))	// 100 msec
				{
					if(Status_KeyBoard_Read() & 0x01) 
				//	if(KeyPad_1_CharReady())
       					{  
   							c_key = KeyPad_1_GetChar();				// translate keypad to PbKey
							KEYRead();
							RoutineKey();                         	// layer keyboard scan 
          					FastKey() ;                           	// gestione pulsanti FAST
						}
				}
    	}          											// end while(1)
	return 0 ;
}
//---------------------------------------------------------------------
//	Setup() initializes US program variables and peripheral registers
//---------------------------------------------------------------------
void Setup(void)
{
	CYGlobalIntDisable		// Disable all interrupts
	segnum = 0;
	parameter = 0;				// Program segment parameters
	ResetFlag() ;                           // reset all flags
	updateProt = 0 ;
	updateView = 0 ;
	Timer_degres = 0 ;                         
	curr_max = 0;
	m_power = 0;
	pwr_max = 0;
	temp.l = 0;
	u0.l = 0;
	u1.l = 0 ;
	m_current = 0;
	blank = 0 ;
/* setting port input/output , some be overwrite */
	Control_US_Write(0) ;
	Control_POWER_Write(0) ;
	Control_KEY_Write(0) ;
	
	updateRamp = 0 ;           // tick for ramp on
	updateTick = 0 ;           // main tick for display , error etc
	updateKey  = 0 ;           // update for increment tick keyboard 
	initial = DELAY_INIT;  		// aggiustamento sistema
	filterProt = 0 ;

// Setup A/D converter
	ADC_SAR_2_Start();
	ADC_SAR_1_Start();
	AMux_1_Start();
	DMA_init();
	Counter_SocADC_Start();

/* used for generating 1 sec pulse marker */
	KeyTick = UPDATE_KEY ;         // inizializzo tempo scan keyboard
	SysTimers_1_Start();
 	update_timerID_Main = SysTimers_1_GetTimer(SysTimers_1_TICKS_PER_SECOND);		// 1 msec
 	update_timerID_Minutes = SysTimers_1_GetTimer(SysTimers_1_TICKS_PER_SECOND* 1000);	// 1 sec
	update_timerID_Keyboard = SysTimers_1_GetTimer(SysTimers_1_TICKS_PER_SECOND* KeyTick);	// 100 msec
	
// Load US generator profile data to RAM for segments1 & segment2
// data EEPROM
	EEPROM_1_Start();
	InitEEPROM() ;

// power parametr
	c_uptime.t =  segment2[0][UPTIME] ;
//	c_tank =  segment2[0][MODEL_TANK] ;
	c_tank =  Status_SYSTEM_Read() & 0x03 ;         //_segment2[0][MODEL_TANK] ;

 // tank selection   
  	tank_parameter(c_tank) ;
	ControlRange();                 

	LcdInit() ;				// inizializzazione LCD
	stat.e_degass = 1 ;
	DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
	stat.e_degass = 0 ; 
								
 // KeyPad
	CYGlobalIntEnable
 	KeyPad_1_Start(KeyPad_1_TransTable);
	
 	LcdNOBlank(VALUE_PROG) ;
 	CyDelay(5) ;							// 5 msec					   
 	LcdNOBlank(VALUE_TEMP) ;
  	CyDelay(5) ;							// 5 msec	
 	LcdNOBlank(VALUE_TIME) ;
  	CyDelay(5) ;							// 5 msec	
 	LcdNOBlank(VALUE_PWR) ;
  	CyDelay(5) ;							// 5 msec	
 	PBkey = P_NONE ;
	c_key = 0 ;
	Calculation() ;				// modifica 23/05/06
}

//---------------------------------------------------------------------
// servo_isr()  US GENERATOR
// Performs the servo calculations every 1 msec ( tmr1 , ccp2)
//---------------------------------------------------------------------
void servo_isr(void)
{
    CyGlobalIntDisable  
	updateRamp++ ;                         // tick for ramp on
    updateTick++ ;                         // main tick for display , error etc
   // updateKey++  ;                         // update for increment tick keyboard 
    Timer_degres++;
    updatePulse++;
    updateView++;
    if(pwm_data < calc_duty) pwm_data++;   // start ramp on PWM
//    if(stat.e_View && (updateView > VIEW) && !stat.e_Enter) 
//        {
//            View_measure() ;
//            updateView = 0 ;
//        }  

//    if(updateKey > 0 ) 
//        {  
//   			PBkey = KeyPad_1_GetChar();			// translate keypad to PbKey
//			RoutineKey();                       // layer keyboard scan 
//          	FastKey() ;                         // gestione pulsanti FAST
//	    }
//	if(!stat.e_StartUs) Calculation();    
//     Acquire() ;                           // DA VERIFICARE POSIZIONE
 	if(!stat.e_StartUs) 
		{
			ref_power = 0 ;      // for start with low power
			Calculation(); 
		}                 
	if(!stat.e_Enter && stat.e_StartUs)
  		{            
     		if((updateRamp > RAMP) && (ref_power < Norm_power) && !stat.e_pulse )
        		{
           			updateRamp = 0 ;
	   				ref_power++ ;                 // Rampa di start accensione
        		}
    		if(!stat.e_simple) Calculation();
       	   	if(updateProt > initial) SysProtAll() ;   
            switch(updateTick)            // setting branch execution 
             	{ 
	       			case 10 : show_adjusted_power() ;
							break ;
					case 20 : if(!stat.eFastUs && !stat.eFastDg && !stat.e_aux) CalcMinutes();  
                           	break ;
               		case 30 : 
							{
								if(!stat.e_degass) 
									{
								if((m_power > c_power) && !stat.e_correct_view) DISPLAYWrite_scan(c_exec,m_degres,m_timer,show_power) ;
								else DISPLAYWrite_scan(c_exec,m_degres,m_timer,m_power) ;
									}
							}
                          	break ;
               		case 40 : updateProt++ ;
                          	break ;
	       			case 41 : updateTick = 0   ;
                          	break ;   
               		default: break ;
               	}
  		}                                    // fine if(!stat.e_Enter)
	CyGlobalIntEnable
}

//---------------------------------------------------------------------
// ControlRange()  control if value stored is in range value
// this is important for the first time programming
//---------------------------------------------------------------------
void ControlRange(void)
{
    if(c_exec > 0x7fff )
       c_exec = 0 ;
    if(c_exec > 9 )
       c_exec = 9 ;
    segnum = c_exec ;
    if(segment1[segnum][USPOWER] > pwr_max)
       segment1[segnum][USPOWER] = pwr_max;
    if(segment1[segnum][USPOWER] < 10 )
       segment1[segnum][USPOWER] = 10;
    if(segment1[segnum][TIMER] > 99)
       segment1[segnum][TIMER] = 99 ;
    if(segment1[segnum][TIMER] < 1)
       segment1[segnum][TIMER] = 1 ;
    if(segment1[segnum][DEGRES] > 70)
       segment1[segnum][DEGRES] = 70 ;
    if(segment1[segnum][DEGRES] < 15)
       segment1[segnum][DEGRES] = 15 ;
    c_power  = segment1[segnum][USPOWER] ;
    c_degres = segment1[segnum][DEGRES] ;
    c_timer  = segment1[segnum][TIMER] ;
}

//---------------------------------------------------------------------
// ControlMeasure()  control if value stored is in range value
// this is important for the first time programming
//---------------------------------------------------------------------
void ControlMeasure(void)
{
    if(m_power > 0x7fff)          // negative
       m_power = 0 ;
    if(m_timer > 0x7fff)
       m_timer = 0 ;
    if(m_degres > 0x7fff)
       m_degres = 0 ;
}

//---------------------------------------------------------------------
// CalcUsPower()
// Gets the new measured power of US generator based on values 
// detect in ilevel and vlevel
//---------------------------------------------------------------------
void CalcUsPower(void)                       // Misurated power and current values 
                                           // are presently stored in t0_power & t0_current
{
    m_power  = (double) m_current * Float_InverseUSScale * Float_Scale;  // power in Watt 
    if( m_power > c_power ) 
        {
            over_power = m_power - c_power ;
			Float_product = over_power ;
			over_power = (m_power - c_power) * Float_over ;
	        m_power = c_power + over_power ;
        }
}                                
//---------------------------------------------------------------------
// void power_USCommand(void)
// simple power control
//---------------------------------------------------------------------
void power_USCommand(void)
{
  	double Vdac_to_Power ;
	Vdac_to_Power = COEFF_VDAC_TO_POWER * (double)ref_power ;
	VDAC8_USPower_SetValue((uint8) Vdac_to_Power) ;
}
//---------------------------------------------------------------------
// Simple_DGPid()
// simple temperature control PID
// F_PIDterm = forward trm ,P_PIDterm = proportional term ,C_PIDterm = command term ,
// PIDterm = final term
//---------------------------------------------------------------------
void Simple_DGPid(void)
{
   	uint32 KF,KP,Lc_degres,Lm_degres,F_PIDterm,P_PIDterm,C_PIDterm,PIDterm;
	uint32 temporary_0;
	// forward term
	KF = (uint32) kfDg ;                            // forwards DG
  	Lc_degres = (uint32)c_degres ;
	F_PIDterm = (Lc_degres * KF) / 1024 ;
  	C_PIDterm = Lc_degres + F_PIDterm ;
    
	// proportional term
	Lm_degres = m_degres ;
	KP = (uint32) kpDg ;                            			// proportional
  	P_PIDterm = C_PIDterm * KP ;            					// Calculate proportional BAND term. 
	PIDterm = P_PIDterm - (P_PIDterm/100);						// salto proporzionale
//            SONOX ROUTINE
//	int_u0.t = WR(acq_degres);               // Get temperature 
//  int_u3.t = WR(PWM_MAXDG) ;               // Constant PWM min duty cycle 95%
//  u0.l = kpDg ;
//  u1.l = PID_temp.t ;
//  u2.l = u0.l * u1.l;                   // Calculate proportional BAND term. 
//  u3.l = u2.l / 100 ;                   // salto proporzionale
//  u2.l = u1.l - u3.l ;
//  u0.l = int_u0.t ;
//	if(u0.l < u2.l) ypid.l = WR(int_u3.t) ;
//  if((u0.l > u2.l) && (u0.l < u1.l))
//        {
//          Float_1stmulti = int_u0.t ;
//          Float_2stmulti = u2.l ;
//          Float_1stmulti = Float_1stmulti - Float_2stmulti ;
//          Float_2stmulti = int_u3.t ;
//          Float_product = Float_1stmulti * Float_2stmulti ;
//          Float_1stmulti = u3.l ;
//          Float_quotient = Float_product / Float_1stmulti ;
//          u4.l = Float_2stmulti - Float_quotient ;
//          ypid.l = u4.l ;
//         }
	
	pwm_limitminDg = PWM_MINDG ;      							// Constant PWM min duty cycle 5%
 	if(Lm_degres < P_PIDterm) ypid.l = PWM_MAXDG ;				// Constant PWM min duty cycle 95%
  	if((Lm_degres > P_PIDterm) && (P_PIDterm < C_PIDterm))
        {
           	temporary_0 = (Lm_degres - P_PIDterm) * PWM_MAXDG ;
           	ypid.l = PWM_MAXDG - (temporary_0 / PIDterm) ;
        }
  	if(ypid.l < pwm_limitminDg) ypid.l = pwm_limitminDg ; 
  	if(Lm_degres >C_PIDterm) ypid.l = pwm_limitminDg ;       
  	if(c_degres < 21)
        { 
			Control_POWER_Write(0);        	//  off heater
            Timer_degres = 0 ;     			// reset timer0
            goto End_DGPid ;
        }
    if(!(Control_POWER_Read()&0x01))
        {
         	if (Timer_degres > ypid.l)
            	{ 
					Control_POWER_Write(0);        	//  off heater
             		Timer_degres = 0 ;     			// reset timer0
            	}
        }
	if(Control_POWER_Read()&0x01)
        {
        	if (Timer_degres > (UPDATE_DG - ypid.l))
           		{ 
					Control_POWER_Write(1);         // on heater
             		Timer_degres = 0;
           		}
         }      
	End_DGPid: ;
}

//---------------------------------------------------------------------
// DISPLAYWrite(int ....) fixed
// Writes an 16 array of integer value to an DISPLAY controller 
// connected to the SPI bus 
//---------------------------------------------------------------------
void DISPLAYWrite(int unsigned d_exec,int unsigned d_degres,int unsigned d_timer,int unsigned d_power)
{
    if(d_power > 0x7fff) d_power = 0 ;
    if((d_power != t0_d_power) || stat.e_degass)
       	{ 
            itoa(d_power,ascii) ;               // display cifre in ascii   
			itoa(d_power,ascii);
            t0_d_power = d_power ;
            LCD_Char_1_WriteControl(VALUE_PWR + 1) ;     // set LCD  address for following Clear B 
            if((d_power < 100) && (d_power > 9))
               	{
                    LCD_Char_1_PutChar(' ') ;
                    for(w=0 ; w < 2 ; w++)
                    LCD_Char_1_PutChar(ascii[w])  ;   ;    // for 1..8 digit
                }
            if(d_power < 10)
                {
                    LCD_Char_1_PutChar(' ') ;
                    LCD_Char_1_PutChar(' ') ;
                    LCD_Char_1_PutChar(ascii[0])  ;   ;    // for 1..8 digit
                }
            if(d_power> 99)
                {
                    for(w=0 ; w < 3 ; w++)
                    LCD_Char_1_PutChar(ascii[w])  ;   ;    // for 1..8 digit
                }
       }
    if(d_timer > 0x7fff) d_timer = 0 ;
    if((d_timer != t0_d_timer) || stat.e_degass)
        {
            itoa(d_timer,ascii) ;               // display cifre in ascii        
            t0_d_timer = d_timer ;
            LCD_Char_1_WriteControl(VALUE_TIME + 1) ;    // set LCD  address for following Clear B 
           	if(d_timer < 10)
                {
                   	LCD_Char_1_PutChar(' ') ;
                   	LCD_Char_1_PutChar(ascii[0]);
                }
            else
                {
                    for(w=0 ; w < 2 ; w++)
                    LCD_Char_1_PutChar(ascii[w])  ;    // for 1..8 digit
                }
        }
    if(d_degres > 0x7fff) d_degres = 0 ;
    if((d_degres != t0_d_degres) || stat.e_degass)
        {
           	itoa(d_degres,ascii) ;              // display cifre in ascii        
           	t0_d_degres = d_degres ;
            LCD_Char_1_WriteControl(VALUE_TEMP + 1 ) ;   // set LCD  address for following Clear B 
            if(d_degres < 10)
                {
                    LCD_Char_1_PutChar(' ') ;
                    LCD_Char_1_PutChar(ascii[0]);
                }
            else
                {
                    for(w=0 ; w < 2 ; w++)
                    LCD_Char_1_PutChar(ascii[w])  ;    // for 1..8 digit
                }
        }
    if(d_exec > 0x7ff) d_exec = 0 ;
    itoa(d_exec,ascii) ;                 // display cifre 1th exec 
    LCD_Char_1_WriteControl(VALUE_PROG + 1) ;  
    LCD_Char_1_PutChar(ascii[0]);
    if(Control_POWER_Read() & 0x01)       
        { 
            LCD_Char_1_WriteControl(VALUE_TEMP + 3) ; // blink on-off heater
            LCD_Char_1_PutChar(0xdf);
        }
    else
        {
            LCD_Char_1_WriteControl(VALUE_TEMP + 3) ; // blink on-off heater
            LCD_Char_1_PutChar(0xa1);              
        }
//  codice parametro blank digit display              
//  blank = 0  no blank
//  blank = 1  exec
//  blank = 2  degres
//  blank = 3  timer
//  blank = 4  US power
//  blank = 5  all 

    switch (blank)
        {
            case 0  :  
                {  	LcdNOBlank(VALUE_PROG) ;
					CyDelay(100) ;			// 100 msec
			       	LcdNOBlank(VALUE_TEMP) ;
					CyDelay(100) ;			// 100 msec
			       	LcdNOBlank(VALUE_TIME) ;
					CyDelay(100) ;			// 100 msec
			       	LcdNOBlank(VALUE_PWR) ;
					CyDelay(100) ;			// 100 msec
			    }
		        break ;
            case 1  :  LcdBlank(VALUE_PROG) ;  	// blank the addressed ":" caracter
                break ;
            case 2  :  LcdBlank(VALUE_TEMP) ;
		        break ;
            case 3  :  LcdBlank(VALUE_TIME) ;
		        break ;
            case 4  :  LcdBlank(VALUE_PWR) ;
		        break ;
            case 5  :  
                {  	LcdBlank(VALUE_PROG) ;
			        LcdBlank(VALUE_TEMP) ;
			        LcdBlank(VALUE_TIME) ;
			        LcdBlank(VALUE_PWR) ;
			    }
	            break ;
            default: break ;  
        }	
}
//---------------------------------------------------------------------
// DISPLAYWrite_scan(int ....) scanning
// Writes an 16 array of integer value to an DISPLAY controller 
// connected to the SPI bus 
//---------------------------------------------------------------------
void DISPLAYWrite_scan(int unsigned d_exec,int unsigned d_degres,int unsigned d_timer,int unsigned d_power)
{
	switch(scan_display)
    	{
      		case 0 :
            	{
              		if(d_power > 0x7fff) d_power = 0 ;
              		if(d_power != t0_d_power)
                  		{
                    		itoa(d_power,ascii) ;               // display cifre in ascii        
                    		t0_d_power = d_power ;
                    		LCD_Char_1_WriteControl(VALUE_PWR + 1) ;     // set LCD  address for following Clear B 
                    		if((d_power < 100) && (d_power > 9))
                        		{
                          			LCD_Char_1_PutChar(' ') ;
                          			for(w=0 ; w < 2 ; w++)
                          			LCD_Char_1_PutChar(ascii[w])  ;   ;    // for 1..8 digit
                        		}
                    		if(d_power < 10)
                        		{
                          			LCD_Char_1_PutChar(' ') ;
                          			LCD_Char_1_PutChar(' ') ;
                          			LCD_Char_1_PutChar(ascii[0])  ;   ;    // for 1..8 digit
                        		}
                    		if(d_power> 99)
                        		{
                          			for(w=0 ; w < 3 ; w++)
                          			LCD_Char_1_PutChar(ascii[w])  ;   ;    // for 1..8 digit
                        		}
                  		}
            	} break ;
     
      		case 1 :
            	{
              		if(d_timer > 0x7fff) d_timer = 0 ;
              		if( d_timer != t0_d_timer)
                   		{
                     		itoa(d_timer,ascii) ;               // display cifre in ascii        
                     		t0_d_timer = d_timer ;
                     		LCD_Char_1_WriteControl(VALUE_TIME + 1) ;    // set LCD  address for following Clear B 
                     		if(d_timer < 10)
                           		{
                             		LCD_Char_1_PutChar(' ') ;
                             		LCD_Char_1_PutChar(ascii[0]);
                           }
                     else
                           {
                             for(w=0 ; w < 2 ; w++)
                             LCD_Char_1_PutChar(ascii[w])  ;    // for 1..8 digit
                           }
                   }
            } break ;

       case 2 :
            {
              if(d_degres > 0x7fff) d_degres = 0 ;
              if( d_degres != t0_d_degres)
                   {
                     itoa(d_degres,ascii) ;              // display cifre in ascii        
                     t0_d_degres = d_degres ;
                     LCD_Char_1_WriteControl(VALUE_TEMP + 1 ) ;   // set LCD  address for following Clear B 
                     if(d_degres < 10)
                         {
                           LCD_Char_1_PutChar(' ') ;
                           LCD_Char_1_PutChar(ascii[0]);
                         }
                    else
                         {
                           for(w=0 ; w < 2 ; w++)
                           LCD_Char_1_PutChar(ascii[w])  ;    // for 1..8 digit
                         }
                   }
             } break ;

       case 3 :
            {
              if(d_exec > 0x7ff) d_exec = 0 ;
              itoa(d_exec,ascii) ;                 // display cifre 1th exec 
              LCD_Char_1_WriteControl(VALUE_PROG + 1) ;  
              LCD_Char_1_PutChar(ascii[0]);
            } break ;

       case 4 : 
            {
              if(Control_POWER_Read() & 0x01)                   
                  { 
                    LCD_Char_1_WriteControl(VALUE_TEMP + 3) ; // blink on-off heater
                    LCD_Char_1_PutChar(0xdf);
                  }
              else
                  {
                    LCD_Char_1_WriteControl(VALUE_TEMP + 3) ; // blink on-off heater
                    LCD_Char_1_PutChar(0xa1);              
                  }
            } break ;


//  codice parametro blank digit display              
//  blank = 0  no blank
//  blank = 1  exec
//  blank = 2  degres
//  blank = 3  timer
//  blank = 4  US power
//  blank = 5  all 

    case 5 :
        {
            switch (blank)
                {
                    case 0  :  
                        {  	LcdNOBlank(VALUE_PROG) ;
							CyDelay(100) ;			// 100 msec
			       			LcdNOBlank(VALUE_TEMP) ;
							CyDelay(100) ;			// 100 msec
			       			LcdNOBlank(VALUE_TIME) ;
							CyDelay(100) ;			// 100 msec
			       			LcdNOBlank(VALUE_PWR) ;
							CyDelay(100) ;			// 100 msec
			    		}
		               	break ;
                   	case 1  :  LcdBlank(VALUE_PROG) ;  	// blank the addressed ":" caracter
                        break ;
                    case 2  :  LcdBlank(VALUE_TEMP) ;
		               	break ;
                    case 3  :  LcdBlank(VALUE_TIME) ;
		               	break ;
                    case 4  :  LcdBlank(VALUE_PWR) ;
		               	break ;
                    case 5  :  
                        {  	LcdBlank(VALUE_PROG) ;
			        		LcdBlank(VALUE_TEMP) ;
			        		LcdBlank(VALUE_TIME) ;
			        		LcdBlank(VALUE_PWR) ;
			     		}
	                   	break ;
                    default: break ;  
                      }	
            	} break ;
			default : break ;
    	}
	scan_display++ ;
 	if(!stat.e_display || (scan_display > 5))
   		{
    		scan_display = 0 ;
    		stat.e_display = 1 ;
   		} 
}
//---------------------------------------------------------------------
// EEWrite()
// Writes an N array of integer value to an EEPROM connected to the SPI bus 
// starting at the specified location.
//---------------------------------------------------------------------
void EEWrite(void)
{
  	temp.b[0] = 0 ; 							// address of first page EEPROM
 	n_pages = PAGE_SEG1 + PAGE_SEG2 ;    		// numero di page da SCRIVERE
	n_bytes = (PAGE_SEG1 + PAGE_SEG2 ) * NUM_BYTES ;    	// n bytes to read from EEPROM and put in ram					
 	usegm = &segment1[0][0] ;              						// primo elemento 
 	transfer.t = 0 ;                   						// posizionato su primo elemento 
    CyGlobalIntDisable
    for (jj=0 ; jj < n_bytes / 2 ; jj++ ) // bytes for page
        { 
			transfer.t = *usegm ;
			EEPROM_1_ByteWrite(transfer.byte[0], jj>>4 , jj);
         	jj++;
			EEPROM_1_ByteWrite(transfer.byte[1], jj>>4 , jj);
			usegm++ ;
        }
	CyGlobalIntEnable
}

//---------------------------------------------------------------------
// EERead()
// Reads an array of  (NUM_BYTES * page ) integer value from an EEPROM connected 
// to the SPI bus 
//---------------------------------------------------------------------
void EERead(void)
{
	uint16 n_bytes,ii;
	n_bytes =(PAGE_SEG1 + PAGE_SEG2) * NUM_BYTES ;    	// n bytes to read from EEPROM and put in ram
	usegm = &segment1[0][0] ;
	transfer.t = 0 ;                             			// posizionato su primo elemento 
    for (ii= 0 ;ii < n_bytes ;ii++ ) 
     	{
			transfer.byte[0] = CY_GET_REG8(CYDEV_EE_BASE + ii) ;	// from eeprom
			ii++;
			transfer.byte[1] = CY_GET_REG8(CYDEV_EE_BASE + ii) ;    			// read from EEPROM
            *usegm = transfer.t ;
            usegm++;                        		// increment pointer
       	}
}

//---------------------------------------------------------------------
// CallDegass()
// routine di gestione e abilitazione degass
//---------------------------------------------------------------------
void CallDegass(void)
{ 
     if(stat.e_StartUs) stat.e_pulse = 1 ;
     if(!stat.e_StartUs)
        {
          	stat.e_pulse = 1 ;
          	stat.e_degass = 1 ;
          	t0_c_exec = c_exec ;                  // save last program
          	PBkey = P_NONE ;
          	blank = 0 ;
          	c_exec = 9 ;
	  		segnum = c_exec ;
	  		SetProg(segnum) ;
          	c_power = pwr_max;
          	str2ram( strbuffer, degass );
          	StringToDisplay() ;             // invio messaggio al display
          
          	Float_1stmulti = c_power ;
          	Float_product  = Float_1stmulti * Float_USScale ;
          	Norm_power     = Float_product ;
	 
          	stat.e_StartUs = 1 ;
	  		StartStopKey();
        }
}

////*********************************************************************
////             ExtStart
////*********************************************************************
//// Purpose:
//// comando esterno per US senza limite di tempo , utilizzando prog ( c_exec = 8 )
//void ExtStart(void)
//{
//    if(stat.e_extStart)
//        {
//            stat.e_aux = 1 ;
//	     	t0_c_exec = c_exec ;
//            PBkey = P_NONE ;
//            blank = 0 ;
//          	c_exec = 8 ;                // execute program 8 = prog. external
//            stat.e_StartUs = 1 ;	
//            segnum = c_exec ;
//	     	SetProg(segnum) ;           // setta  program executed c_exec
//            StartStopKey() ;
//	    }
//    if(!stat.e_extStart )
//        { 
//            stat.e_aux = 0 ;
//            stat.e_StartUs = 0 ;
//            StartStopKey() ;
//	     	EERead() ;
//            c_exec = t0_c_exec ;
//            segnum = c_exec ;
//            SetProg(segnum) ;              // setta last program executed c_exec
//             //StartStopKey() ;
//        }
//}      
//---------------------------------------------------------------------
// StartStopKey()
// Start_Stop Key input Keyboard and referes command
//---------------------------------------------------------------------
void StartStopKey(void) 
{  
    filterProt = 0 ;
    stat.e_simple = 0 ;
    half_second = 0 ;
    blank = 0 ;
    if(!stat.e_Enter)                          // start blocked if system is in setting routine
      	{
        	if(!stat.e_StartUs )
          		{
                  //	SetDCPwm(3);                         // Write the new PWM US duty cycle = 0
           			m_power = 0 ;			// reset i valori misurati
           			m_timer = 0 ;
           			blank = 0 ;
           			stat.e_pulse = 0 ;
           			if(stat.e_degass)
              			{
                 			str2ram( strbuffer, mask );
                 			StringToDisplay() ;                   // invio mask al display
                 			c_exec = t0_c_exec ;
                 			segnum = c_exec ;
                 			SetProg(segnum) ;              // setta last program executed c_exec
                 			DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
                 			stat.e_degass = 0 ;
               			}
           			ControlRange();
           			DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
           			if(!stat.eFastDg) Control_ENA_POWER_Write(1);
           			ref_power = 0 ;
		   			Calculation();    
        		}
   			if(stat.e_StartUs)
        		{
           			channel = 0 ;						// restart from channel 0
           			scan_calc = 0 ;						// restart from calculation first sequence
		   			updateRamp = 0 ;                    // tick for ramp on
           			pwm_data = PWM_MINUS ;	       		// start for ramp PWM
            		updateTick = 0 ;                    	// main tick for display , error etc
           			updateProt = 0 ;
	        		ref_power = 0 ;		       // start con rampa
           			blank = 0 ;
           			m_timer = c_timer ;             // carico timer
           			if(!stat.e_degass && !stat.e_extStart)
              			{
                			EERead() ;
                			segnum = c_exec ;
                			SetProg(segnum) ;                // setta program be executed c_exec
							DISPLAYWrite(c_exec,m_degres,m_timer,m_power);
              			}
        			if(stat.eFastUs && !stat.eFastDg) c_degres = 15 ;  // significa c_degres = 15°C
           			if(stat.eFastDg && !stat.eFastUs) Norm_power = 0 ;
					//           Control_ENA_POWER_Write(0) ;
       			}
		}
	PBkey = P_NONE ;
}
 
//---------------------------------------------------------------------
// SysProtAll() 
// gestione protezioni varie
//---------------------------------------------------------------------
void SysProtAll(void) 
{  
    updateProt = 64000 ;
    prot_current = m_current / 2 ;
	if (prot_current > curr_max) stat.curr_max = 1;   // max value allowed 
    else stat.curr_max = 0 ;

//        if ((m_current < curLoad_low) && (m_volt > VOL_LOADHIGH)) stat.f_LoadLow = 1;
//        else stat.f_LoadLow = 0 ;                    // circuito trasduttori aperto
    stat.f_LoadLow = 0	;							// modifica sicurezza	

//        if((prot_current > curLoad_high) && (m_volt < VOL_LOADLOW)) stat.f_LoadHigh = 1;                     // corto circuito trasduttori 
//        else stat.f_LoadHigh = 0 ;
	stat.f_LoadHigh = 0	;							// modifica sicurezza

    if (m_degres < 2) stat.f_HighPwr = 1 ;        // protezione termica esterna
    else stat.f_HighPwr = 0 ;

    if(m_degres > DEGRESLIM) stat.f_HighTemp = 1;
    else stat.f_HighTemp = 0;

 	if(stat.curr_max || stat.f_LoadLow || stat.f_LoadHigh ||
     			stat.f_HighPwr || stat.f_HighTemp ) filterProt++;
 	else filterProt = 0 ;

 	if((filterProt > TIME_PROT) || stat.e_Fault)
        { 
			Control_ENA_POWER_Write(1) ;   
          //	SetDCPwm(3);			              // Write the new PWM US duty cycle = 0
           	stat.e_StartUs = 0 ;
	  		StartStopKey() ;
            stat.e_Fault = 1 ;
        } 
 	if((stat.curr_max || stat.f_LoadLow || stat.f_LoadHigh || stat.f_HighPwr) && stat.e_Fault )
        { 
			str2ram( strbuffer, gen_prot );
           	StringToDisplay() ;             // invio messaggio al display
       	}
 	if(stat.f_HighTemp && stat.e_Fault)
        { 	
			str2ram( strbuffer, tank_prot );
           	StringToDisplay() ;             // invio messaggio al display
	 	}
}
     
//---------------------------------------------------------------------
// CalcMinutes()
// gestione timer , conteggio minuti
//---------------------------------------------------------------------                   
void CalcMinutes(void) 
{
    if ((half_second > 120) || (half_second == 120))        // equivalgono a 1 minute
        { 
            m_timer --;
            half_second = 0 ;             	// ricarico 120 / 2 second 
        }
    if (m_timer <= 0 )
        {
       //     SetDCPwm(3);                       // Write the new PWM US duty cycle = 0
            m_power = 0 ;			// reset i valori misurati
            m_timer = 0 ;
            DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
            Control_ENA_POWER_Write(1) ;
            stat.e_StartUs = 0 ;
            stat.e_pulse = 0 ;                 // stop funzionamento ad impulsi
            if(stat.e_degass)
            	{
                 	c_exec = t0_c_exec ;
                 	segnum = c_exec ;
                 	SetProg(segnum) ;              // setta last program executed c_exec
                 	str2ram( strbuffer, mask );
                 	StringToDisplay() ;             // invio maschera al display
                 	DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
		 			stat.e_degass = 0 ;            // termina degass
                }
        }
}
   
//---------------------------------------------------------------------
// ResetFlag()
// routine di Reset all flag stat.xx
//---------------------------------------------------------------------
void ResetFlag(void)
{
	stat.e_StartUs   = 0 ;         // Enable start ciclo
	stat.e_Enter     = 0 ;         // Enter command  
	stat.e_Press     = 0 ;         // Press key flag    
	stat.f_LoadLow   = 0 ;         // flag di carico basso (poco liquido)
	stat.f_LoadHigh  = 0 ;         // flag di carico alto  (oggetto su fondo)
	stat.f_HighPwr   = 0 ;         // flag di overheating TRIAC & IGBT
	stat.pwr_max     = 0 ;         // flag di over power limit US
	stat.curr_max    = 0 ;         // flag di over current limit US
	stat.f_HighTemp  = 0 ;         // flag di over temperature HEATER
	stat.e_StartPwr  = 0 ;         // flag di main power 
	stat.e_degass    = 0 ;
	stat.e_aux       = 0 ;
	stat.e_extStart  = 0 ;
	stat.e_ADC       = 0 ;
	stat.e_ScanCalc  = 0 ;
	stat.e_pulse     = 0 ;
	stat.e_First_Acq = 0 ;
	stat.e_First_Sync = 0 ;
	stat.e_display = 0 ;
	stat.e_View = 0 ;
	stat.e_P_UP = 0 ;            // flag pressione P_UP
	stat.e_P_DN = 0 ;            // flag pressione P_DOWN
	stat.e_simple = 0 ;
	stat.eFastUs = 0 ;
	stat.eFastDg = 0 ;
	stat.eSSPress = 0 ;
	stat.eDGPress = 0 ;
	stat.eFastKey = 0 ;
	stat.eInterEna = 0 ;
	stat.e_Fault = 0 ;
	stat.e_correct_view = 0 ;
}


//***********************************************************************************************
//                               TERMINAL
//***********************************************************************************************
// Code 
// LCD initialisation 
// Clear display 
// Cursor home 
// Display mode 
// Write character 
// Write command 
// Requirements & features
// - HD44780-based (industry-standard) character-LCD, all software in this chapter is based
// on it's instruction-set.

//*************************************************************
//                        Lcd Initialisation
//*************************************************************
// Purpose:
// LCD initialisiation code to be executed after power-up 
// (i.e.: before any other subroutines are used).
// Should be modified to your needs (i.e. display type, cursor on/off, etc.)
void LcdInit(void)
{
  	LCD_Char_1_Start();
    LCD_Char_1_ClearDisplay() ;
    str2ram( strbuffer, name );
    StringToDisplay() ;                    			// invio name al display
    CyDelay(2000) ;
	switch(c_tank)
		{
			case 0:    str2ram( strbuffer, model0 ); break ; 
			case 1:    str2ram( strbuffer, model1 ); break ; 
			case 2:    str2ram( strbuffer, model2 ); break ; 
			case 3:    str2ram( strbuffer, model3 ); break ; 
		}			
    StringToDisplay() ;                    			// invio model al display
    CyDelay(2000) ;       
    str2ram( strbuffer, mask );
    StringToDisplay() ;                   			// invio mask al display
          
}
//*********************************************************************
//                             LcdBlank
//*********************************************************************
// Purpose:
// Blank the caracter addressed with data 
void LcdBlank(unsigned char data)
{
	LCD_Char_1_WriteControl(data) ;
	LCD_Char_1_WriteControl(0x0d) ;	// blank at the cursor address
}                

//*********************************************************************
//                             LcdNOBlank
//*********************************************************************
// Purpose:
// Stop Blank the caracter addressed with data 
void LcdNOBlank(unsigned char data)
{
 	LCD_Char_1_WriteControl(data) ;
 	LCD_Char_1_WriteControl(0x0c) ;	// NO blank at the cursor address
    LCD_Char_1_PutChar(':')  ;
} 
                               
//*********************************************************************
//                             LcdClear 
//*********************************************************************
// Purpose:
// Clears display and returns cursor to home position (upper-left corner).
void LcdClear(void)
{
    LCD_Char_1_WriteControl(0x01);
}

//*********************************************************************
//                          LcdHome
//*********************************************************************
// Purpose:
// - Returns cursor to home position.
// - Returns display to original position (when shifted).
void LcdHome(void)
{
    LCD_Char_1_WriteControl(0x02) ;
}

//*********************************************************************
//             StringToDisplay
//*********************************************************************
// Purpose:
// transition from ROM to ram & display char 	
void StringToDisplay(void)
{
 	LCD_Char_1_Position(0,0);
	MORONI_LCD_Char_1_PrintString(strbuffer) ;
//	LCD_Char_1_PrintString(strbuffer) ;
}

//********************************************************************
//	void MORONI_LCD_Char_1_PrintString(char8 const string[]) 
//********************************************************************+
void MORONI_LCD_Char_1_PrintString(char8 const string[]) 
{
    uint8 indexU8 = 1u;
    char8 current = *string;

    /* Until null is reached, print next character */
    while((char8) '\0' != current)
    {
        if((indexU8 == 22) && (current == '~')) LCD_Char_1_PutChar(0xdf);
		else LCD_Char_1_WriteData((uint8)current);
        current = string[indexU8];
        indexU8++;
		if(indexU8 == 17) LCD_Char_1_Position(1,0);
    }
}
//*********************************************************************
//             str2ram
//*********************************************************************
// Purpose:
// copy rom to Ram
void str2ram( char *dest, const char  *src)
{
	while( (*dest++ = *src++) != 0 ) ;
} 

//*********************************************************************
//             pwm_ram
//*********************************************************************
// Purpose:
// copy level_pwm lookup table record to Ram
void pwm_ram(const int *therm)
{
	ram_duty = *therm ;
} 

//------------------------------------------------------------------------------ 
//   InitEEPROM( void ) Initialize EEPROM
//------------------------------------------------------------------------------ 
void InitEEPROM(void)
{
	EERead() ;
	first0 = segment2[0][FIRST] ;
	usegm = &segment1[0][0] ;
	segnum =(PAGE_SEG1 + PAGE_SEG2) * NUM_BYTES;
	if(first0 != 0xaa)
    	{
      		for(i=0; i< segnum;i++)
         	{
           		*usegm = 0 ;
           		usegm++;
         	}
        }                                         // setting variabili to x25xx values stored
    for(i=0;i<10;i++) segment1[i][EXEC]= i ;   // indice programmi non modificabile     
    segment2[0][FIRST]      = 0xaa ;    
    segment2[0][UPTIME]     = UPTIME_DF;
    segment2[0][MODEL_TANK] = 9;
    segment2[0][PWR_MAX]    = 100 ;
    EEWrite() ;
}
//---------------------------------------------------------------------
// Acquire()
// Gets the new measured values of sensor 
//---------------------------------------------------------------------
void Acquire(void)                       
{
	uint32 timeout,RT ;
	uint16 temp_current,temp_vth,temp_thermistor ;
	uint8 i ;
	AMux_1_FastSelect(0) ;    		//select VTH VTL
	CyDelayUs(20) ;  
	Control_ADC_Write(0);			// start soc temp and current
	Control_ADC_Write(1);			// start soc temp and current
	Control_ADC_Write(0);			// start soc temp and current
	timeout = 0 ;
	while(timeout < MAX_TIMING) timeout++;
		{
			if(Status_ADC_CURRENT_Read() & 0x01)
				{
					temp_current = 0 ;
					for(i=0;i<NUMBER_ACQ;i++) temp_current += current[i] ;
				}
			if(Status_ADC_TEMP_Read() & 0x01)
				{
					temp_vth = 0 ;
					for(i=0;i<NUMBER_ACQ;i++) temp_vth += therm[i] ;
				}
		}			
//	if(timeout > MAX_TIMING-2) error = 1 ;
	AMux_1_FastSelect(1) ;    		//select VTH VTL
	CyDelayUs(20) ;  
	Control_ADC_Write(0);			// start soc temp and current
	Control_ADC_Write(1);			// start soc temp and current
	Control_ADC_Write(0);			// start soc temp and current
	timeout = 0 ;
	while(timeout < MAX_TIMING) timeout++;
		{
			if(Status_ADC_CURRENT_Read() & 0x01)
				{
					for(i=0;i<NUMBER_ACQ;i++) temp_current += current[i] ;
				}
			if(Status_ADC_TEMP_Read() & 0x01)
				{
					temp_vth = 0 ;
					for(i=0;i<NUMBER_ACQ;i++) temp_thermistor += therm[i] ;
				}
		}	  
	//	if(timeout > MAX_TIMING-2) error = 1 ;
	m_current = temp_current >>= N_ADC_SHIFT + 1 ;
	temp_vth >>= N_ADC_SHIFT ;
	temp_thermistor >>= N_ADC_SHIFT;
	RT = Thermistor_1_GetResistance(temp_vth, temp_thermistor);	
	m_degres = Thermistor_1_GetTemperature(RT);
}
//---------------------------------------------------------------------
// Calculation()
// Gets the new PID values of regolation 
//---------------------------------------------------------------------
void Calculation(void) 
{ 
	switch(scan_calc)
    	{
        	case 0 : CalcUsPower();           // calcola power from m_current
                       break ;
            case 1 : power_USCommand();	      // Calculate VDAC output
					 if(stat.e_StartUs) Control_ENA_POWER_Write(0) ;
                       break ;
           	case 2 : Simple_DGPid();                // calcola PID degres
                       break ;
              default: break ;
   		} 

scan_calc++ ;
if(!stat.e_ScanCalc || (scan_calc > 2))			// at fist time
   {
    scan_calc = 0 ;
    stat.e_ScanCalc = 1 ;
   }     
}

//****************************************************************************+ 
// void view_Temperature(void)
//***************************************************************************
void view_Temperature(void)
{
   	if(stat.eFastKey ) temp_time++ ;   // visualizzazione temperatura corrente
   	if(temp_time > 10)
     	{
      		temp_time = 0 ;
      		stat.eFastKey = 0 ;
      		DISPLAYWrite(c_exec,c_degres,c_timer,c_power); 
     	}
}

//------------------------------------------------------------------------------------------------------
//   show_adjusted_power()   aggiusta potenza da mostrare su display
//------------------------------------------------------------------------------------------------------
void show_adjusted_power(void)
{
	int temp_calc ;
	temp_calc = m_power - c_power ;
    temp_calc = temp_calc / 5 ;
    show_power = c_power + temp_calc ;
}
//******************************************************************+
// void itoa(unsigned int value,char *buffer)
//********************************************************************
void itoa(unsigned int value,char *buffer)
{
	sprintf(buffer,"%d", value) ;
}
//***************************************************************************
//	void DMA_init(void)
//*****************************************************************************
void DMA_init(void)
{
	DMA_Current_Chan = DMA_Current_DmaInitialize(DMA_Current_BYTES_PER_BURST, DMA_Current_REQUEST_PER_BURST, 
    	HI16(DMA_Current_SRC_BASE), HI16(DMA_Current_DST_BASE));
	DMA_Current_TD[0] = CyDmaTdAllocate();
	CyDmaTdSetConfiguration(DMA_Current_TD[0], 32, CY_DMA_DISABLE_TD, DMA_Current__TD_TERMOUT_EN | TD_INC_DST_ADR);
	CyDmaTdSetAddress(DMA_Current_TD[0], LO16((uint32)ADC_SAR_1_SAR_WRK0_PTR), LO16((uint32)&current[0]));
	CyDmaChSetInitialTd(DMA_Current_Chan, DMA_Current_TD[0]);
//CyDmaChEnable(DMA_Current_Chan, 1);

	DMA_Therm_Chan = DMA_Therm_DmaInitialize(DMA_Therm_BYTES_PER_BURST, DMA_Therm_REQUEST_PER_BURST, 
    	HI16(DMA_Therm_SRC_BASE), HI16(DMA_Therm_DST_BASE));
	DMA_Therm_TD[0] = CyDmaTdAllocate();
	CyDmaTdSetConfiguration(DMA_Therm_TD[0], 32, CY_DMA_DISABLE_TD, DMA_Therm__TD_TERMOUT_EN | TD_INC_DST_ADR);
	CyDmaTdSetAddress(DMA_Therm_TD[0], LO16((uint32)ADC_SAR_2_SAR_WRK0_PTR), LO16((uint32)&therm[0]));
	CyDmaChSetInitialTd(DMA_Therm_Chan, DMA_Therm_TD[0]);
//CyDmaChEnable(DMA_Therm_Chan, 1);
	
	ADC_dma_enable();
}
//-----------------------------------------------------------------------------------------------
// void ADC_dma_release(void) release all TTL relate dma 
//-----------------------------------------------------------------------------------------------
void ADC_dma_release(void)
{
	DMA_Therm_DmaRelease();
	DMA_Current_DmaRelease();
}
//-----------------------------------------------------------------------------------------------
// void ADC_dma_enable(void) enable DMA with fixing
//-----------------------------------------------------------------------------------------------
void ADC_dma_enable(void)
{
	CyDmaChEnable_FIX(DMA_Therm_Chan);
	CyDmaChEnable_FIX(DMA_Current_Chan);
}
	
//*********************************************************************************************
// CyDmaChEnable_FIX(uint8 chHandle) By Chris Keeser
// To clear unwanted transfer requests (DRQ)
//*********************************************************************************************
void CyDmaChEnable_FIX(uint8 DMA_Channel)
{
	CyDmaClearPendingDrq(DMA_Channel) ;
	// To clear unwanted transfer requests (DRQ), issue a CPU terminate chain request
	CyDmaChSetRequest(DMA_Channel, CPU_TERM_CHAIN);

	// Enable the DMA channel, This enable kills the spurious DMA transaction if there is one
	// and disables the channel, must re-enable
	CyDmaChEnable(DMA_Channel, 1);

	// re-enable the DMA channel
	CyDmaChEnable(DMA_Channel, 1);
}
//******************************************************************************+
// uint8 test_KeyBoard(uint8 column) column = 1,2
//*******************************************************************************+
uint8 test_KeyBoard(uint8 column)
{
	uint8 value;
	value = column ;
//	if(column==0) value = 0b11011111 ;
//	else value = 0b10111111 ;
	KeyPad_1_Columns_Write(value) ;
	return  KeyPad_1_Rows_Read() ;
}
/* [] END OF FILE */
