/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <device.h>
#include <project.h>
#include <stdlib.h>
#include <string.h>
#include "definition.h"
#include "programming.h"
//---------------------------------------------------------------------
// SetProg(unsigned char segnum)
// Gets data for program segment to be executed
//---------------------------------------------------------------------
void SetProg(unsigned char segnum)
{
	if(segnum < 10)					      // Get profile segment data from
		{					      // data memory.
        	c_degres = segment1[segnum][DEGRES];
        	c_timer  = segment1[segnum][TIMER];
        	c_power  = segment1[segnum][USPOWER];
		}
	ControlRange() ;
	pwm_limitminUs = PWM_MINUS ;            // min value pwm   
	// Norm_power = (CURR_LIM_MAX * level_power) / pwr_max
	// trovo la entry table level_pwm = c_power/pwr_max * 40 ;
	entry_table = (c_power * 40) / pwr_max ;
	pwm_ram(level_pwm + entry_table ) ;			// lookup table level_pwm -> ram_duty 

	Float_USScale  = (double)CURR_LIM_MAX / (double) pwr_max ;			// used in others calculation
	Float_InverseUSScale = (double)pwr_max / (double)CURR_LIM_MAX ;
	Norm_power = (c_power * Float_USScale  * ram_duty) / 256 ;
}

//---------------------------------------------------------------------
// KEYRead()
// routine di gestione input pulsanti
//---------------------------------------------------------------------
void KEYRead()
{   
    switch(c_key)
        {
       	    case 0x38: 
                {
                  	PBkey = START_STOP ;
                  	stat.eSSPress = 1 ;
                }  	break;                     // flag del tasto premuto 00111000
           	case 0x39: 
                {
                  	PBkey = PAUSE_ENTER ;                      // old P_DEGRES
                }   break;                     // 00111001
            case 0x1d: 
                {
                  	PBkey = P_DOWN ;                     // old P_EXEC ;
                  	stat.e_P_DN = 1 ;
                }   break;                     // 00011101
            case 0x34: 
                {
                  	PBkey = P_EXEC ;                  // old PAUSE_ENTER ;
                }   break;                     // 00110100
            case 0x2d: 
                {
                  	PBkey = P_TIMER ;                    // old P_USPOWER ; 
                }   break;                     // 00101101
            case 0x35:
                {
                  	PBkey = P_DEGRES ;                 // old P_TIMER
                  	stat.eDGPress = 1 ;
                }        break ;                     // 00110101
            case 0x28:
                {
                  	PBkey = P_FAST_US ;                 // old P_TIMER
                }  	break ;                     // 00110101
            case 0x2c:
                {
                  	PBkey = P_USPOWER ;                   // old P_DOWN ; 
                } 	break ;                     // 00101100
            case 0x1c:
                {
                  	PBkey = P_UP ;
                  	stat.e_P_UP = 1 ;
                }        break;                      // 00011100
            default:  break ;  
        }
		
// da implementare
    if(stat.eSSPress && stat.eDGPress) PBkey = P_FAST_DG ; // chiamo fast degres
    stat.eSSPress = 0 ;
    stat.eDGPress = 0 ;     
    if(stat.e_P_UP && stat.e_P_DN) PBkey = P_DEGASS ; // chiamo degass 
    stat.e_P_UP = 0 ;
    stat.e_P_DN = 0 ;
             
}        
//---------------------------------------------------------------------
// RoutineKey()
// routine di gestione pressione avvenuta dei pulsanti
//---------------------------------------------------------------------
void RoutineKey(void)
{
	updateKey = 0 ;
	switch(PBkey)
      	{
       		case(P_FAST_US) :
           		{
                 	stat.eFastUs = 1 ;
           		} break ;
       		case(P_FAST_DG) :
           		{
                    stat.eFastDg = 1 ;
           		} break ;
          	case(START_STOP) :
           		{
            		if(!stat.e_Enter)
              			{ 
               				stat.e_StartUs = !stat.e_StartUs;
               				stat.eFastDg = 0;
               				stat.eFastUs = 0 ;
               				StartStopKey();                   // chiama gestione start/stop
              			}
           		}      break ;
       	case(PAUSE_ENTER) :
           	{ 
            	if(!stat.e_StartUs)
               		{
                		stat.e_Enter = !stat.e_Enter;
                		EnterKey();                   // chiama gestione set/enter
               		}
            	else stat.e_Enter = 0 ;
           	}      break ;
       	case(P_DEGRES) : NewDegresValue() ;    // chiama gestione cambio valore
                  break ;
       	case(P_TIMER ) : NewTimerValue() ;     // chiama gestione cambio valore
                  break ;    
       	case(P_EXEC)   : NewProgValue() ;      // chiama gestione cambio valore
                  break ;
       	case(P_USPOWER): NewPowerValue() ;     // chiama gestione cambio valore
                  break ;
       	case(P_DEGASS) : CallDegass() ;
                  break ;
       	case(P_UP)     : CallKeyUD() ;
                  break ;
       	case(P_DOWN)   : CallKeyUD() ;
                  break ;      
       	default:   KeyTick = UPDATE_KEY ;
                  break ;
      }  
}

//---------------------------------------------------------------------
// FastKey()
// routine di gestione pressione avvenuta dei pulsanti FAST
//---------------------------------------------------------------------
void FastKey(void)
{
	if(stat.eFastUs && (PBkey == P_FAST_US))
      	{
            PBkey = P_NONE ;
        	stat.e_StartUs = 1 ;
        	StartStopKey() ;
      	}
	if(stat.eFastDg && (PBkey == P_FAST_DG))
      	{
           PBkey = P_NONE ;
        	stat.e_StartUs = 1 ;
        	StartStopKey() ;
      	}
}
//---------------------------------------------------------------------
// ProgKey(int p_value,int max_value,int min_value,
//         unsigned char step)
// routine di programmazione ProgKey()   e ritorna il valore adeguato
//---------------------------------------------------------------------
int ProgKey(int p_value,int max_value,int min_value,unsigned char step)
{
    if(step_Up)
        { 
			p_value = p_value + step;
            step_Up = 0 ;
            if ( p_value  > max_value) 
               	{ 
					p_value = max_value;
                } 
        }    
    if(step_Down)
        { 
			p_value = p_value - step;
            step_Down = 0 ;
            if(p_value < min_value)
            p_value = min_value;
            if(p_value > 0x7fff)
            p_value = 0 ;
        }
   	return p_value ;                      // ritorna il valore modificato
}
//---------------------------------------------------------------------
// NewProgValue()
// routine di gestione aggiornamento valori
//---------------------------------------------------------------------
void NewProgValue(void)
{
	if(!stat.e_StartUs && stat.e_Enter)
     	{   
            Prog_Func =    P_EXEC ;
      		blank =1 ; 
      		ControlRange() ;
      		DISPLAYWrite(c_exec,c_degres,c_timer,c_power) ;
     	}  
	PBkey = P_NONE ;
}                     
//---------------------------------------------------------------------
// NewDegresValue()
// routine di gestione aggiornamento valori
//---------------------------------------------------------------------
void NewDegresValue(void)
{
	if(!stat.e_StartUs && !stat.e_Enter)
     	{
           	stat.eFastKey = 1 ;
      		temp_time = 0 ;                 // variabile visualizzazione temperatura
      		DISPLAYWrite(c_exec,m_degres,c_timer,c_power);  
     	}
	if (!stat.e_StartUs && stat.e_Enter)
     	{   
           Prog_Func =  P_DEGRES ;
      		blank = 2 ;
      		ControlRange() ;
      		DISPLAYWrite(c_exec,c_degres,c_timer,c_power); 
     	} 
PBkey = P_NONE ;
}                     
//---------------------------------------------------------------------
// NewTimerValue()
// routine di gestione aggiornamento valori
//---------------------------------------------------------------------
void NewTimerValue(void)
{
	if(!stat.e_StartUs && stat.e_Enter)
     	{   
           Prog_Func =  P_TIMER ;
      		blank = 3 ;
      		ControlRange() ;
      		DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
     	}   
PBkey = P_NONE ;
}                     
//---------------------------------------------------------------------
// NewPowerValue()
// routine di gestione aggiornamento valori
//---------------------------------------------------------------------
void NewPowerValue(void)
{
	if (!stat.e_StartUs && stat.e_Enter)
     	{
            Prog_Func =  P_USPOWER ;
      		blank = 4 ;
      		ControlRange() ;
      		DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
    	}  
PBkey = P_NONE ;
}                     
//---------------------------------------------------------------------
// CallKeyUD()
// routine di gestione pulsanti Up & Down
//---------------------------------------------------------------------
void CallKeyUD(void)
{
 	if(stat.e_Enter)
   		{
    		switch(PBkey)
             	{
              		case P_DOWN :
                  		{
                   			step_Up = 0 ;
                   			step_Down = 1 ;
                   			KeyTick = KeyTick - KEYTIME ;           // aumenta velocita refresh  
                   			if(KeyTick < KEY_MIN_TIME)
                      		KeyTick = KEY_MIN_TIME   ;           // limita velocita refresh   
 							update_timerID_Keyboard = SysTimers_1_GetTimer(SysTimers_1_TICKS_PER_SECOND* KeyTick);	// 100 msec
						}    break ;         
              		case P_UP:
                  		{
                   			step_Up = 1 ;
                   			step_Down = 0 ; 
                   			KeyTick = KeyTick - KEYTIME ;           // aumenta velocita refresh  
                   			if(KeyTick < KEY_MIN_TIME)
                      		KeyTick = KEY_MIN_TIME   ;           // limita velocita refresh   
 							update_timerID_Keyboard = SysTimers_1_GetTimer(SysTimers_1_TICKS_PER_SECOND* KeyTick);	// 100 msec
						}    break ;
              		default: break ;
              	}
        	ControlRange() ;                                                                        
        	switch(Prog_Func)
             	{
              		case P_DEGRES :                        
                   		{
                    		segnum = c_exec ;
                    		p_value = segment1[segnum][DEGRES] ;
                    		segment1[segnum][DEGRES] = ProgKey(p_value,70,15,1);
                    		c_degres = segment1[segnum][DEGRES];
                   		} break ; 
              		case P_TIMER :                        
                   		{
                    		segnum = c_exec ;
                    		p_value = segment1[segnum][TIMER] ;
                    		segment1[segnum][TIMER] = ProgKey(p_value,99,1,1);
                    		c_timer = segment1[segnum][TIMER] ;
                   		}  break ;
              		case P_USPOWER :                        
                   		{
                    		segnum = c_exec;
                    		p_value = segment1[segnum][USPOWER] ;
                    		segment1[segnum][USPOWER] = ProgKey(p_value,pwr_max,10,10);
                    		c_power = segment1[segnum][USPOWER];
                   		}  break ;
              		case P_EXEC :                        
                   		{
                    		p_value = c_exec;
                    		c_exec = ProgKey(p_value,9,0,1); 
                    		segnum = c_exec ;
                    		SetProg(segnum);
                    		ControlRange();
                    		t0_c_exec = c_exec ;         // salva il valore attuale
                   		}   break ;
              		default: break ;
            	}  
          	ControlRange() ;
         	DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
     	}
PBkey = P_NONE ;  
}
//---------------------------------------------------------------------
// EnterKey()
// Enter Key Input Keyboard and referes command
//---------------------------------------------------------------------
void EnterKey(void)
{   
    PBkey = P_NONE ;
    if(!stat.e_StartUs)
      	{
         	if(!stat.e_Enter)
           		{ 
	     		//	StartBuzzer();
                    blank = 0 ;
             		DISPLAYWrite(c_exec,c_degres,c_timer,c_power);
             		EEWrite();
             		Prog_Func = P_NONE ;
           		}
         	if(stat.e_Enter)
           		{
                   	EERead() ;
             		Prog_Func = P_EXEC ;
             		NewProgValue() ;                   // chiama gestione cambio valore
           		}
      	}
}
//******************************************************************************+
// void tank_parameter( uint8 tank) adjust parameter dependig from the tank
// c_tank = 3  Sonox
// c_tank = 2  MDV low
// c_tank = 1  MDV medium
// c_tank = 0  MDV high
//********************************************************************************
void tank_parameter( uint8 tank)
{
 	// view adapt
	view_100 = SCALE_G100 ;
	view_200 = SCALE_G200 ;
	view_300 = SCALE_G300 ;
	view_400 = SCALE_G400  ;

	view_100 = view_100 / 100 ;
	view_200 = view_200 / 100 ;
	view_300 = view_300 / 100 ;
	view_400 = view_400 / 100 ;
	Float_over = SCALE_OVER / 100 ;
	switch( tank )    // select with type capacity in liter
        { 
          	case   3 :	curr_max = CURR_LIM_MAX ;
                      	pwr_max  = segment2[0][PWR_MAX] ;
                      	adc1_gain = ADC1_G100 ;
		      			Float_Scale = view_100 ;  break ;           
           	case   2 :  curr_max = CURR_LIM_MAX ;
                      	pwr_max  = segment2[0][PWR_MAX] ;
                      	adc1_gain = ADC1_G200 ;
		      			Float_Scale = view_200 ; break ;
          	case   1 :	curr_max = CURR_LIM_MAX ;
                      	pwr_max  = segment2[0][PWR_MAX] ;
                      	adc1_gain = ADC1_G300 ;
		      			Float_Scale = view_300 ; break ;
          	case   0 : 	curr_max = CURR_LIM_MAX ;
                      	pwr_max  = segment2[0][PWR_MAX] ;
                      	adc1_gain = ADC1_G400 ;
		      			Float_Scale = view_400 ; break ;
          	default:	curr_max = CURR_LIM_MAX ;
                      	pwr_max  = 100 ;
                      	adc1_gain = ADC1_G100 ;
                      	c_tank = 9 ;
		      			Float_Scale = view_100 ; break ;
        }
    curLoad_low  = CUR_LOADLOW ;   
    curLoad_high = CUR_LOADHIGH;

	c_exec = 0 ;
	SetProg(c_exec) ;                            		// riparte sempre da zero
	
	// Norm_power = (CURR_LIM_MAX * level_power) / pwr_max
	// trovo la entry table level_pwm = c_power/pwr_max * 40 ;
	entry_table = (c_power * 40) / pwr_max ;
	pwm_ram(level_pwm + entry_table ) ;			// lookup table level_pwm -> ram_duty 

	Float_USScale  = (double)CURR_LIM_MAX / (double) pwr_max ;			// used in others calculation
	Float_InverseUSScale = (double)pwr_max / (double)CURR_LIM_MAX ;
	Norm_power = (c_power * Float_USScale  * ram_duty) / 256 ;
}         
/* [] END OF FILE */
